--联盟系统 加入联盟限制Item
Lua_AllianceLimitItem = class("Lua_AllianceLimitItem", Lua_DisplayObject);

function Lua_AllianceLimitItem:ctor(p, showType, data, initData)
	self.showType = showType;
	self.data = data;
	self.initData = initData;
	self:superCall("ctor", p, "AllianceLimitItem_skin");
end

function Lua_AllianceLimitItem:buildShowItem()
	self:superCall("buildShowItem");

	self.curLevel = 1;
	self.showLevel = 1;
	if self.showType == 1 then
		if self.initData ~= nil then
			self.showLevel = Mathf.Ceil(self.initData / self.data[3]);
		end
		self.totalLevel = Mathf.Floor((self.data[2] - self.data[1]) / self.data[3]);
	else
		if self.initData ~= nil then
			self.showLevel = self.initData;
		end
		self.totalLevel = #self.data;
	end

	self:updataShow();

	self.subBtn:addClickFuntion(self, self.onSubBtnClick);
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
end

function Lua_AllianceLimitItem:dispose()
	self:superCall("dispose");
end

function Lua_AllianceLimitItem:updataShow()
	local isMin = self.showLevel <= 1;
	local isMax = self.showLevel >= self.totalLevel;
	if isMin then
		self.showLevel = 1;
	elseif isMax then
		self.showLevel = self.totalLevel;
	end

	if isMin then
		self.subBtn:setAltas("alliance_atlas_1", "ui_sq_button_001_d");
	else
		self.subBtn:setAltas("alliance_atlas_1", "ui_sq_button_001_n");
	end

	if isMax then
		self.addBtn:setAltas("alliance_atlas_1", "ui_sq_button_001_d");
	else
		self.addBtn:setAltas("alliance_atlas_1", "ui_sq_button_001_n");
	end
	self.subBtn.mouseEnable = not isMin;
	self.addBtn.mouseEnable = not isMax;

	if self.showType == 1 then
		if isMin then
			self.limitTxt:setLangValue(201110);
		else
			self.limitTxt.text = numberTrans(self.showLevel * self.data[3]);
		end
	else
		self.limitTxt.text = self.data[self.showLevel];
	end
	self.curLevel = self.showLevel;
end

function Lua_AllianceLimitItem:onSubBtnClick(go)
	self.showLevel = self.showLevel - 1;
	self:updataShow();
end

function Lua_AllianceLimitItem:onAddBtnClick(go)
	self.showLevel = self.showLevel + 1;
	self:updataShow();
end

function Lua_AllianceLimitItem.Get:getRealValue()
	local realValue = 0;
	if self.showType == 1 then
		if self.curLevel > 1 then
			realValue = self.curLevel * self.data[3];
		end
	else
		realValue = self.curLevel - 1;
	end
	return realValue;
end