--联盟系统 权限菜单Window
Lua_AllianceMenuListWindow = class("Lua_AllianceMenuListWindow", Lua_Window)
function Lua_AllianceMenuListWindow:ctor()
	self:superCall("ctor");

	self.isClickClose = true;
	self.showBlackMask = true;
	self.showClose = false;
	self.showWinBg = false;
	self.showBlackMask = true;
	self.blackAlpha = 0.02;

	self.windowName = "Lua_AllianceMenuListWindow";
end

function Lua_AllianceMenuListWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.bgW = 200;
	self.bgH = 55;

	self.mainObj = UICreate.createGameObject(self.content, 0, 0, 0);
	self.mainMenuBg = UICreate.createUIAtlasImage(self.mainObj, "common_altas_1", "ui_common_window_009", 0, 0, self.bgW, self.bgH);

	self:addLuaEvent("OPEN_MENULIST_SUBBTN", self, self.showSubBtn);
end

function Lua_AllianceMenuListWindow:showWin(param)
	self:superCall("showWin", param);
	if param == nil or param.menuArr == nil then
		self:hide();
		return;
	end

	self.btnList = Array();
	local num = param.menuArr:getSize();
	local showH = self.bgH * num + 25;
	local data;
	for i = 1, num do
		data = param.menuArr[i];
		local btn = Lua_AllianceMenuListBtn.new(self.mainObj);
		btn:setData(data);
		btn:setLocation(0, -40 - (i - 1) * 55 + showH / 2, 0);
		self.btnList:add(btn);
	end
	self.mainMenuBg:SetDimensions(self.bgW, showH);

	local posX = param.posX;
	local posY = param.posY;
	if posX == nil or posY == nil then
		local winPos = LuaUtil.getTouchPosInverseObj(self.content);
		posX = winPos.x;
		posY = winPos.y;
		local half_w = self.bgW / 2;
		local half_h = showH / 2;
		if posX > 0 then
			if posX + self.bgW > self.width / 2 then
				posX = posX - half_w - 10;
			else
				posX = posX + half_w + 10;
			end
		else
			posX = posX + half_w + 10;
		end

		if posY < 0 and posY - half_h < -self.height / 2 then
			posY = posY + half_h;
		end
	end
	LuaUtil.setObjPos(self.mainObj, posX, posY, 0);
end

function Lua_AllianceMenuListWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.mainMenuBg ~= nil then
		self.mainMenuBg:dispose();
		self.mainMenuBg = nil;
	end
	if self.showSubList ~= nil then
		self.showSubList:dispose();
		self.showSubList = nil;
	end
	if self.hideSubList ~= nil then
		self.hideSubList:dispose();
		self.hideSubList = nil;
	end
	if self.subObj ~= nil and IsNil(self.subObj) == false then
		UnityEngine.GameObject.Destroy(self.subObj);
		self.subObj = nil;
	end
	if self.subMenuBg ~= nil then
		self.subMenuBg:dispose();
		self.subMenuBg = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceMenuListWindow:showSubBtn(mainBtnType)
	if self.mainBtnType ~= mainBtnType then
		self.mainBtnType = mainBtnType;

		local selectIndex = 0;
		local menuArr = self.showData.menuArr;
		for i = 1, menuArr:getSize() do
			if menuArr[i].mainBtnType == self.mainBtnType then
				selectIndex = i;
				break;
			end
		end

		if selectIndex == 0 or menuArr[selectIndex].subListData == nil then
			return;
		end

		if self.subObj == nil then
			self.subObj = UICreate.createGameObject(self.content, 0, 0, 0);
			self.subMenuBg = UICreate.createUIAtlasImage(self.subObj, "common_altas_1", "ui_common_window_009", 0, 0, self.bgW, self.bgH);

			local data = menuArr[selectIndex].subListData;
			local num = data:getSize();
			local showH = self.bgH * num + 25;
			local btn;
			for i = 1, num do
				btn = self:createSubBtn(data[i]);
				btn:setLocation(0, -40 - (i - 1) * 55 + showH / 2, 0);
			end
			self.subMenuBg:SetDimensions(self.bgW, showH);

			local pos = self.mainObj.transform.localPosition;
			local posX = pos.x;
			if posX + self.bgW + self.bgW / 2 > self.width / 2 then
				posX = posX - self.bgW;
			else
				posX = posX + self.bgW;
			end
			LuaUtil.setObjPos(self.subObj, posX, pos.y, 0);
		end

		self.subObj:SetActive(true);
	else
		self.mainBtnType = nil;
		if self.subObj ~= nil then
			self.subObj:SetActive(false);
		end
	end
end

function Lua_AllianceMenuListWindow:createSubBtn(data)
	if self.showSubList == nil then
		self.showSubList = Array();
	end
	if self.hideSubList == nil then
		self.hideSubList = Array();
	end

	local btn;
	if self.hideSubList:getSize() > 0 then
		btn = self.hideSubList:shift();
		btn:setEnable(true);
	else
		btn = Lua_AllianceMenuListBtn.new(self.subObj);
	end
	btn:setData(data);
	self.showSubList:add(btn);
	return btn;
end

function Lua_AllianceMenuListWindow:returnSubBtnToPool()
	if self.showSubList == nil or self.showSubList:getSize() <= 0 then return end

	local len = self.showSubList:getSize();
	local btn;
	for i = 1, len do
		btn = self.showSubList:shift();
		btn:setEnable(false);
		self.hideSubList:add(btn);
	end
end






























Lua_AllianceMenuListBtn = class("Lua_AllianceMenuListBtn", Lua_DisplayObject)

function Lua_AllianceMenuListBtn:ctor(p)
	self:superCall("ctor", p, "AllianceMenuListBtn_skin");
end

function Lua_AllianceMenuListBtn:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_AllianceMenuListBtn:dispose()
	self:superCall("dispose");
end

function Lua_AllianceMenuListBtn:setData(data)
	self.btnBg:clearListener();
	self.btnBg:addClickFuntion(data.owner, data.onClick);

	self.btnTxt.text = data.btnName;
end