--联盟系统 主界面Window
Lua_MyAlliancePanel = class("Lua_MyAlliancePanel", Lua_DisplayObject);

function Lua_MyAlliancePanel:ctor(p)
	self:superCall("ctor", p, "MyAlliancePanel_skin");
end

function Lua_MyAlliancePanel:buildPanel()
	self:superCall("buildPanel");
	self:addLuaEvent("UPDATE_LEAGUE_INFO", self, self.updateData);
	-- self:addLuaEvent("UPDATE_LEAGUE_LOGLIST", self, self.updateLogData);
end

function Lua_MyAlliancePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.tipTxt1:setLangValue(201237);
	self.tipTxt2:setLangValue(201238);
	
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sGetAllianceInfo();
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sGetLogList();
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceBossInfo(0);

	local config = getConfig("league_entrance");
	local item;
	local data;
	self.btnItemArr = Array();
	for i = 1, #config do
		data = config[i];
		if data.is_shield ~= 1 then
			item = Lua_AllianceBtnItem.new(self.content, data);
			item:setLocation(data.pos[1], data.pos[2], 0);
			item:setRectAnchor(1);
			self.btnItemArr:add(item);
		end
	end
end

function Lua_MyAlliancePanel:dispose()
	if self.btnItemArr ~= nil then
		self.btnItemArr:dispose();
		self.btnItemArr = nil;
	end
	if self.leaderInfoItemArr ~= nil then
		self.leaderInfoItemArr:dispose();
		self.leaderInfoItemArr = nil;
	end
	self:superCall("dispose");
end

function Lua_MyAlliancePanel:updateData()
	local myLeagueInfo = DataCenter.allianceData.myLeagueInfo;
	self.leagueNameTxt.text = LanUtil.formateStr(201113, myLeagueInfo.showLeagueName, myLeagueInfo.level);
	self.memberNumTxt.text = LanUtil.formateStr(201100, myLeagueInfo.memberAmount, myLeagueInfo.maxMember);
	self.noticeTxt.text = myLeagueInfo.declaration;

	self.expBar:setMaxValue(myLeagueInfo.curLevelVo.build_val_cond);
	self.expBar:setValue(myLeagueInfo.buildExp);
	self.expBar:setText(myLeagueInfo.buildExp .. "/" .. myLeagueInfo.curLevelVo.build_val_cond);

	if self.leaderInfoItemArr == nil then
		self.leaderInfoItemArr = Array();
	end

	local leaderInfoList = DataCenter.allianceData.leaderInfoList;
	local infolen = #leaderInfoList;
	local arrLen = self.leaderInfoItemArr:getSize();
	local maxLen = infolen > arrLen and infolen or arrLen;

	local item;
	local postion;
	local index = 0;
	for i = 1, maxLen do
		item = self.leaderInfoItemArr[i];
		if item == nil then
			item = Lua_AllianceLeaderInfoItem.new(self.content);
			item:setRectAnchor(1);
			self.leaderInfoItemArr:add(item);
		end

		if i <= infolen then
			postion = leaderInfoList[i].member_position;
			if postion == 1 then
				item:setLocation(-295, -348, 0);
			else
				item:setLocation(-295, -413 - index * 30, 0);
				index = index + 1;
			end
			item:setEnable(true);
			item:setData(leaderInfoList[i]);
		else
			item:setEnable(false);
		end
	end
	self:updateLogData();
end

function Lua_MyAlliancePanel:updateLogData()
	if self.logItemArr == nil then
		self.logItemArr = Array();
	end

	local arr = DataCenter.allianceData.topLogList;
	local showLine = 3;
	local infactLine = 0;
	if arr ~= nil then
		arr:sort("log_tick", true);
		infactLine = arr:getSize();
	end


	local item;
	for i = 1, showLine do
		item = self.logItemArr[i];
		if item == nil then
			item = Lua_MyAllianceLogItem.new(self.content);
			item:setRectAnchor(7);
			self.logItemArr:add(item);
		end
		item:setLocation(0, 208 - (i - 1) * 38, 0);
		if i <= infactLine then
			item:setData(arr[i]);
			item:setEnable(true);
		else
			item:setEnable(false);
		end
	end
end




























Lua_AllianceBtnItem = class("Lua_AllianceBtnItem", Lua_DisplayObject);
function Lua_AllianceBtnItem:ctor(p, data)
	self.data = data;
	self:superCall("ctor", p);
end

function Lua_AllianceBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnBg = UICreate.createUIAtlasImage(self.content, "alliance_atlas_2", "ui_sq_window_005", 0, 0, 0, 0);
	self.btnBg:addClickFuntion(self, self.onBtnClick);

	self.btnTxt = UICreate.createLabel(self.content, self.data.name, 0, 0, 100, 40, 24);
	self.btnTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.btnTxt.alignmentValue = 4;
	self.btnTxt:setEffectDistance(2, 2);

	if self.data.path_id ~= nil then
		self:addLuaEvent("FIGHTPLAY_ENTER", self, self.checkFighting);
		self:addLuaEvent("FIGHTPLAY_COMPLETE", self, self.checkFighting);
	end

	if self.data.redDot_id ~= nil then
		self.redPointIcon = Lua_RedPointIcon.new(self.content, self.data.redDot_id);
		self.redPointIcon:setLocation(50, 10, 0);
	end

	if self.data.id == 4 then
		self:updateData();
		self:addLuaEvent("UPDATE_LEAGUE_INFO", self, self.updateData);
		self:addLuaEvent("UPDATE_LEAGUE_ACTIVE_VALUE", self, self.updateData);
	end
	self:checkFighting();
end

function Lua_AllianceBtnItem:dispose()
	if self.btnBg ~= nil then
		self.btnBg:dispose();
		self.btnBg = nil;
	end
	if self.btnTxt ~= nil then
		self.btnTxt:dispose();
		self.btnTxt = nil;
	end
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceBtnItem:updateData()
	if self.valueBg == nil then
		self.valueBg = UICreate.createUIAtlasImage(self.content, "alliance_atlas_2", "ui_tdq_window_001", 0, -38, 0, 0);
	end
	if self.valueTxt == nil then
		self.valueTxt = UICreate.createLabel(self.content, nil, 0, -38, 100, 31, 20);
		self.valueTxt.alignmentValue = 4;
	end
	local active_value = DataCenter.allianceData.active_value;
	active_value = active_value == nil and 0 or active_value;
	local limit_value = DataCenter.allianceUtil:getConstConfig("open_league_challenge_active_consume", 1);
	self.valueTxt.text = Lua_ColorDefine.getColorStr("37D652", active_value).."/"..limit_value;
end

function Lua_AllianceBtnItem:checkFighting()
	if self.data.path_id ~= nil then
		local vo = DataCenter.funcPathUtil:getFuncPathVo(self.data.path_id);
		local list = vo.template_list;
		local recordId = 0;
		if list ~= nil then
			for i = 1, #list do
				recordId = DataCenter.fightData:getRecordIdByTemplateId(list[i]);
				if recordId > 0 then
					break;
				end
			end
		end
		
		if recordId > 0 then
			if self.fightEff == nil then
				self.fightEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ty_zdbs_0101", "ui_ty_zdbs_0101", 0, 45);
				self.fightEff:setScale(0.5, 0.5, 0.5)
			end
			self.fightEff:setEnable(true);
		else
			if self.fightEff ~= nil then
				self.fightEff:setEnable(false);
			end
		end
	end
end

function Lua_AllianceBtnItem:onBtnClick(go)
	if strIsNullOrEmpty(self.data.win_name) then
		DataCenter.funcPathUtil:gotoFunction(self.data.path_id)
	else
		Lua_WindowUtil.openWin(self.data.win_name, Lua_WinParam.ACTION_OPEN);
	end
end


















Lua_AllianceLeaderInfoItem = class("Lua_AllianceLeaderInfoItem", Lua_DisplayObject);

function Lua_AllianceLeaderInfoItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_AllianceLeaderInfoItem:buildShowItem()
	self:superCall("buildShowItem");

	self.nameTxt = UICreate.createLabel(self.content, "", 25, 0, 150, 30, 20);
	self.nameTxt.colorStr = Lua_ColorDefine.transColorStr("ffe7b3");

	self.btn = UICreate.createUIAtlasImage(self.content, "friend_altas", "ui_hy_button_007_n", 130, 5, 0, 0);
	self.btn:setScale(0.7, 0.7);
	self.btn:addClickFuntion(self, self.onBtnClick);
end

function Lua_AllianceLeaderInfoItem:dispose()
	if self.nameTxt ~= nil then
		self.nameTxt:dispose();
		self.nameTxt = nil;
	end
	if self.btn ~= nil then
		self.btn:dispose();
		self.btn = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceLeaderInfoItem:setData(data)
	self.data = data;
	self.nameTxt.text = data.member_name;
end

function Lua_AllianceLeaderInfoItem:onBtnClick(go)
	if DataCenter.roleData.roleId == tonumber(self.data.member_id) then
		OperateAlert.show( LanUtil.getValue(123656) );
		return;
	end
	Lua_WindowUtil.openWin("Lua_PlayerInfoWindow", Lua_WinParam.ACTION_OPEN,
		{id = tonumber(self.data.member_id), server_flag = self.data.server_flag});
end





















Lua_MyAllianceLogItem = class("Lua_MyAllianceLogItem", Lua_DisplayObject);

function Lua_MyAllianceLogItem:ctor(p)
	self:superCall("ctor", p, "MyAllianceLogItem_skin");
end

function Lua_MyAllianceLogItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_MyAllianceLogItem:dispose()
	self:superCall("dispose");
end

function Lua_MyAllianceLogItem:setData(data)
	self.logTxt.text = data.content;

	local sec = DataCenter.roleData.serverTime - data.log_tick;
	local hour = Mathf.Modf(sec / 3600);
	if hour < 1 then
		if sec < 60 then
			self.timeTxt.text = LanUtil.formateStr(201119, "1");
		else
			self.timeTxt.text = LanUtil.formateStr(201119, Mathf.Modf(sec / 60));
		end
	elseif hour < 48 then
		self.timeTxt.text = LanUtil.formateStr(201120, hour);
	elseif hour < 168 then
		self.timeTxt.text = LanUtil.formateStr(201121, "2");
	else
		self.timeTxt.text = LanUtil.formateStr(201121, "7");
	end
end