--联盟系统 Boss伤害排行Window
Lua_AllianceBossHurtRankWindow = class("Lua_AllianceBossHurtRankWindow", Lua_Window);

function Lua_AllianceBossHurtRankWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.isClickClose = true;
	self.showBlackMask = true;

	self.windowName = "Lua_AllianceBossHurtRankWindow";
	self.skinName = "AllianceBossHurtRankWindow_skin";
end

function Lua_AllianceBossHurtRankWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_LEAGUE_BOSSHURTRANK", self, self.updateData);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceBossHurtRankWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);

	self.dragList = Lua_DragList.new(self.content, 645, 510, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_AllianceBossHurtRankItem, 645, 139, 1);
    self.dragList:setLocation(0, -145, 0);
end

function Lua_AllianceBossHurtRankWindow:dispose()
	if self.avatarItem == nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	if self.dragList == nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceBossHurtRankWindow:showWin(param)
	self:superCall("showWin", param);
	self.titleTxt.text = LanUtil.formateStr(201201, tostring(param));
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceBossHurtRank(param);
end

function Lua_AllianceBossHurtRankWindow:updateData()
	self.dragList:setArrayData(DataCenter.allianceData.bossHurtArr);
end





























Lua_AllianceBossHurtRankItem = class("Lua_AllianceBossHurtRankItem", Lua_ListCell);

function Lua_AllianceBossHurtRankItem:ctor(p)
	self:superCall("ctor", p, "AllianceBossHurtRankItem_skin");
end

function Lua_AllianceBossHurtRankItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rankNum = Lua_NumberImage.new(self.content);
	self.rankNum:setLocation(-256, 0, 0);
	self.rankNum.pivot = 0;
	self.rankNum.numOffsetX = -4;
	self.rankNum.numAtlas = "number";
	self.rankNum.preStr = "ui_djc_title_0";

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setScale(0.75, 0.75);
	self.avatarItem:setLocation(-146, 0, 0);

	self.recordIcon:addClickFuntion(self, self.onRecoIconClick);
	self.replayIcon:addClickFuntion(self, self.onReplayIconClick);
	self.likeIcon:addClickFuntion(self, self.onLikeBtnClick);
end

function Lua_AllianceBossHurtRankItem:dispose()
	if self.rankNum ~= nil then
		self.rankNum:dispose();
		self.rankNum = nil;
	end
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceBossHurtRankItem:setData(data)
	self.data = data;
	if data.rank < 4 then
		self.rankBg:setAltas("common_altas_3", "ui_djc_window_00"..data.rank);
		self.rankNum.num = nil;
	else
		self.rankBg:setAltas("common_altas_3", "ui_djc_window_004");
		self.rankNum.num = data.rank;
	end
	self.nameTxt.text = data.playerName;
	self.hurtTxt.text = numberTrans(data.hurt);

	self.avatarItem:setRoleAvatar(data.headIcon);

	if tonumber(data.isPraised) == 0 and DataCenter.allianceData.leftPraiseNum > 0 then
		self.likeIcon.mouseEnable = true;
		self.likeIcon:setAltas("common_altas_2", "ui_common_button_038_n");
	else
		self.likeIcon.mouseEnable = false;
		self.likeIcon:setAltas("common_altas_2", "ui_common_button_037_n");
	end
end

function Lua_AllianceBossHurtRankItem:onRecoIconClick()
	if self.data.fightRecordId == nil then
		return;
	end

	if self.data.fightRecordId == 0 then
		OperateAlert.showLangValue(201232);
		return
	end
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightHurtCollect(self.data.fightRecordId, Lua_FightDefine.LEAGUE_BOSS_RECORD);
end

function Lua_AllianceBossHurtRankItem:onReplayIconClick()
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(self.data.fightRecordId, 0, "", 0, Lua_FightDefine.LEAGUE_BOSS_VIDEO);
end

function Lua_AllianceBossHurtRankItem:onLikeBtnClick()
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceHurtRankLike(self.data.playerId, DataCenter.allianceData.showId);
end          