--联盟系统 Boss排行奖励Window
Lua_AllianceBossRankRewardWindow = class("Lua_AllianceBossRankRewardWindow", Lua_Window);
function Lua_AllianceBossRankRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_AllianceBossRankRewardWindow";
	self.skinName = "AllianceBossRankRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_AllianceBossRankRewardWindow:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);

	self.dragList = Lua_DragList.new(self.content, 625, 735, Lua_AxisDefine.Vertical);
	self.dragList:setLocation(0, -25, 0);
	self.dragList:setListCell(Lua_AllianceBossRankRewardItem, 625, 180, 1);
end

function Lua_AllianceBossRankRewardWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceBossRankRewardWindow:showWin(param)
	self:superCall("showWin", param);

	local arr = DataCenter.allianceUtil:getBossRankRewardArr(param);
	self.dragList:setArrayData(arr);
end

















Lua_AllianceBossRankRewardItem = class("Lua_AllianceBossRankRewardItem", Lua_ListCell);
function Lua_AllianceBossRankRewardItem:ctor(p)
	self:superCall("ctor", p, "AllianceBossRankRewardItem_skin");
end

function Lua_AllianceBossRankRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_ItemIconList.new(self.content);
	self.rewardList:setLocation(-235, -18, 0);
	self.rewardList.pivot = 1;
end

function Lua_AllianceBossRankRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceBossRankRewardItem:setData(data)
	if data.rank[1] == data.rank[2] then
		self.titleText.text = LanUtil.formateStr(201200, tostring(data.rank[1]));
	else
		self.titleText.text = LanUtil.formateStr(201200, data.rank[1] .. "-" .. data.rank[2]);
	end
	local rewardConfig = Lua_RewardConfigData.getConfigDataById(data.reward).client_show;
	self.rewardList:setArrayData(rewardConfig);
end

function Lua_AllianceBossRankRewardItem:onPressClick()
	self.rewardList:onBoundClick();
end