--联盟系统 Boss主界面Window
checkRequire("Lua_AllianceHurtItem");
Lua_AllianceBossWindow = class("Lua_AllianceBossWindow", Lua_Window);

function Lua_AllianceBossWindow:ctor()
	self:superCall("ctor");

	self.isFullSizeWin = true;
	self.showBackBtn = true;
	-- self.showBlackMask = true;
	self.isSingleShowWin = true;
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER

	self.windowName = "Lua_AllianceBossWindow";
	self.skinName = "AllianceBossWindow_skin";
end

function Lua_AllianceBossWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	-- self:addLuaEvent("FIGHTPLAY_ENTER", self, self.checkIsFighting);
	-- self:addLuaEvent("FIGHTPLAY_COMPLETE", self, self.checkIsFighting);
	self:addLuaEvent("UPDATE_LEAGUE_BOSSINFO", self, self.updateData);
	self:addLuaEvent("UPDATE_LEAGUE_BOSSBUFF", self, self.updateBuff);
	self:addLuaEvent("UPDATE_LEAGUE_MASSCOOL", self, self.updateMassShow);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceBossWindow:buildShowItem()
	self:superCall("buildShowItem");

	if Lua_WindowUtil.isWindowShowing("Lua_ChatWindow") then
		Lua_WindowUtil.openWin("Lua_ChatWindow", Lua_WinParam.ACTION_CLOSE);
	end

	self.dragList = Lua_DragList.new(self.content, 700, 110, Lua_AxisDefine.Horizontal);
	self.dragList:setListCell(Lua_AllianceBossItem, 100, 110, 1);
	self.dragList:setRectAnchor(1);
    self.dragList:setLocation(0, -64, 0);

	self.rankArr = Array();
	local item;
	for i = 1, 3 do
		item = Lua_AllianceHurtItem.new(self.upObj);
		item:setLocation(-320, 460 - (i - 1) * 60, 0);
		item:setRank(i);
		self.rankArr:add(item);
	end

	self.threatRewardArr = Lua_DragList.new(self.downObj, 270, 124, Lua_AxisDefine.Horizontal);
	self.threatRewardArr:setLocation(-158, -349, 0);
	self.threatRewardArr:setListCell(Lua_ItemIconCell, 124, 124, 1);
	self.threatRewardArr:setCellSpacing(5, 0);

	self.killRewardArr = Lua_DragList.new(self.downObj, 270, 124, Lua_AxisDefine.Horizontal);
	self.killRewardArr:setLocation(176, -349, 0);
	self.killRewardArr:setListCell(Lua_ItemIconCell, 124, 124, 1);
	self.killRewardArr:setCellSpacing(5, 0);

    self.buffActiveBtn:addClickFuntion(self, self.onActivateBtnClick);
    self.rankRewardBtn:addClickFuntion(self, self.onRankRewardBtnClick);
    self.massBtn:addClickFuntion(self, self.onMassBtnClick);
    self.hurtDetailTxt:addClickFuntion(self, self.onHurtDetailBtnClick);
    self.remainAddBtn:addClickFuntion(self, self.onRemainAddBtnClick);
    self.challengeBtn:addClickFuntion(self, self.onChallengeBtnClick);
    self.sweepBtn:addClickFuntion(self, self.onSweepBtnClick);
    self.tipIcon:addClickFuntion(self, self.tipIconClick);

    Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceBossInfo(0);
end

function Lua_AllianceBossWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.rankArr ~= nil then
		self.rankArr:dispose();
		self.rankArr:clear();
		self.rankArr = nil;
	end
	if self.modelScenePanel then
		self.modelScenePanel:dispose()
		self.modelScenePanel = nil
	end
	if self.threatRewardArr ~= nil then
		self.threatRewardArr:dispose();
		self.threatRewardArr = nil;
	end
	if self.killRewardArr ~= nil then
		self.killRewardArr:dispose();
		self.killRewardArr = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onCountDown);
	Lua_CommonUtil.removeTimer(self, self.onMassTimeDown);
	DataCenter.preLoadData:removeBySign("Lua_FightLineupWindow", self, self.onSceneShow);
	self:superCall("dispose");
end

function Lua_AllianceBossWindow:showWin(param)
	self:superCall("showWin", param);

	if param.modelScenePanel then
		self.modelScenePanel = param.modelScenePanel
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
		param.modelScenePanel = nil
	end
end

function Lua_AllianceBossWindow:updateData()
	if not self.bActive then
		return;
	end

	local data = DataCenter.allianceData;
	if self.isFirst == nil then
		self.isFirst = true;
		self.dragList:setArrayData(DataCenter.allianceUtil.getAllianceBossArr);
		self.dragList:moveToIndex(data.showId, true);
	end
	self.dragList:updateShowList();
	self.dragList:setSelected(data.showId);

	self.remainBuyTxt.text = LanUtil.formateStr(201162, data.leftBuyTimes);
	self.remainNumTxt.text = data.leftTimes;

	table.sort(data.rankList, function(a, b) return a.rank < b.rank end);
	local len = #data.rankList;
	for i = 1, 3 do
		if len >= i then
			self.rankArr[i]:setData(data.rankList[i]);
		else
			self.rankArr[i]:setData(nil);
		end
	end

	local bossStageInfo = data.bossStageInfo;
	self.titleTxt.text = LanUtil.formateStr(201179, bossStageInfo.id, bossStageInfo.name);
	self.nameTxt.text = bossStageInfo.monsterData.name;

	local bloodRatio = data.leftBlood / data.maxBlood;
	if bloodRatio > 0 and bloodRatio <= 0.01 then
		bloodRatio = string.format("%.3f", 0.001) * 100;
	else
		bloodRatio = string.format("%.2f", bloodRatio) * 100;
	end
	
	self.bloodBar:setText(tostring(bloodRatio) .. "%");
	self.bloodBar:setMaxValue(data.maxBlood);
	self.bloodBar:setValue(data.leftBlood);

	if data.showId < data.topId then
		self.challengeBtn:setBtnEnable(false);
		self.sweepBtn:setBtnEnable(false);
		self.defeatIcon:setEnable(true);

		self.buffIcon:setEnable(false);
		self.buffTImeTxt:setEnable(false);
		self.buffActiveBtn:setEnable(false);
		self.buffActiveTxt:setEnable(false);
	else
		self.challengeBtn:setBtnEnable(true);
		self.sweepBtn:setMouseEnable(true);
		self.sweepBtn:setGray(DataCenter.allianceData.lastHurt <= 0)
		self.defeatIcon:setEnable(false);

		self.buffIcon:setEnable(true);
		self.buffTImeTxt:setEnable(true);
		self.buffActiveBtn:setEnable(true);
		self.buffActiveTxt:setEnable(true);
	end

	self.headIcon:setAltas(bossStageInfo.monsterVo.avatar_atlas_1, bossStageInfo.monsterVo.avatar_sprite_1);
	self:updateBuff();
	self:updateMassShow();
	self:updateReward(bossStageInfo);
	self:updateModel(bossStageInfo.monsterVo);
end

function Lua_AllianceBossWindow:updateModel(data)
	if data == nil then
		if self.modelScenePanel ~= nil then
			self.modelScenePanel:dispose();
			self.modelScenePanel = nil;
		end
		return
	end

	if self.modelScenePanel == nil then
		self.modelScenePanel = Lua_ModelScenePanel.new()
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
	end

	if self.bInitModel or not self.modelScenePanel.bShowModel then
		self.modelScenePanel:setModelDir(data.uiModelDir);
		self.modelScenePanel:setModelScale(data.uiModelScale);
		self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, data.poseActEffs);
		self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, data.showActEffs);
		self.modelScenePanel:showModelScene(data.uiSceneId, data.uiModelUrl, data.uiModelAvatarName, data.uiModelCamController);
		self.modelScenePanel:setModelAct(data.uiShowAct, Lua_ThingDefine.UIWAIT, true);
	end
	
	self.bInitModel = true
end

function Lua_AllianceBossWindow:updateBuff()
	self.buffStr = LanUtil.formateStr(201156, tostring(DataCenter.allianceData.buffAdd));
	self.timer = DataCenter.allianceData.buffLast - DataCenter.roleData.serverTime;
	if self.timer > 0 then
		if not self.isOnTimer then
			self.isOnTimer = true;
			Lua_CommonUtil.addTimer("onCountDown", 1, self, self.onCountDown);
			self.buffTImeTxt.text = self.buffStr .. " " .. LanUtil.formateStr(201157, Lua_TimeTransform.transSeconds6(self.timer, true, true, true));
		end
	else
		self.isOnTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onCountDown);
		self.buffTImeTxt.text = self.buffStr .. " " .. LanUtil.getValue(201158);
	end
end

function Lua_AllianceBossWindow:updateReward(data)
	self.threatRewardArr:setArrayData(data.fight_reward);
	if DataCenter.allianceData.is_have_kill <= 0 then
		self.killRewardArr:setArrayData(data.kill_reward);
	else
		self.killRewardArr:setArrayData(data.second_kill_reward);
	end
end

function Lua_AllianceBossWindow:onCountDown()
	self.timer = self.timer - 1;
	if self.timer > 0 then
		self.buffTImeTxt.text = self.buffStr .. " " .. LanUtil.formateStr(201157, Lua_TimeTransform.transSeconds6(self.timer, true, true, true));
	else
		if self.isOnTimer then
			self.isOnTimer = false;
			Lua_CommonUtil.removeTimer(self, self.onCountDown);
			self.buffTImeTxt.text = self.buffStr .. " " .. LanUtil.getValue(201158);
		end
	end
end

function Lua_AllianceBossWindow:updateMassShow()
	if DataCenter.allianceData:getCurDutyPower(Lua_AllianceData.OPERATION_TYPE.BOSS_ASSEMBLY) then
		self.massTimer = DataCenter.allianceData.coolEndTick - DataCenter.roleData.serverTime;
		if self.massTimer > 0 then
			if not self.isOnMassTimer then
				self.isOnMassTimer = true;
				Lua_CommonUtil.addTimer("onMassTimeDown", 1, self, self.onMassTimeDown);
				self.massTimeTxt.text = Lua_TimeTransform.transSeconds6(self.massTimer, true, true, true);
			end
		else
			self.massTimeTxt.text = "";
		end
		self.massObj:SetActive(DataCenter.allianceData.showId == DataCenter.allianceData.topId);
	else
		Lua_CommonUtil.removeTimer(self, self.onMassTimeDown);
		self.massObj:SetActive(false);
	end
end

function Lua_AllianceBossWindow:onMassTimeDown()
	self.massTimer = self.massTimer - 1;
	if self.massTimer > 0 then
		self.massTimeTxt.text = Lua_TimeTransform.transSeconds6(self.massTimer, true, true, true);
	else
		if self.isOnMassTimer then
			self.isOnMassTimer = false;
			Lua_CommonUtil.removeTimer(self, self.onMassTimeDown);
			self.massTimeTxt.text = "";
		end
	end
end

function Lua_AllianceBossWindow:onActivateBtnClick()
	local costInfo = DataCenter.allianceUtil:getConstConfig("league_boss_buff", 5);
	local addProp = DataCenter.allianceUtil:getConstConfig("league_boss_buff", 7);
	local totalProp = DataCenter.allianceUtil:getConstConfig("league_boss_buff", 6);
	local time = DataCenter.allianceUtil:getConstConfig("league_boss_buff", 1) / 3600;

	local tipsData = {
		des = LanUtil.formateStr(201159, costInfo[2], spliceIconStrById(costInfo[1]), addProp, time, totalProp),
		btnType = 1,
		owner = self,
		sureFun = function()
			if DataCenter.moneyData:isMoneyEnough(costInfo[1], costInfo[2], true, false, false) then
				Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAddAllianceBossBuff();
			end
		end
	};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_AllianceBossWindow:onMassBtnClick()
	if self.massTimer > 0 then
		OperateAlert.show(LanUtil.formateStr(201161, Lua_TimeTransform.transSeconds6(self.massTimer, true, true)));
		return;
	end
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceBossMass();
	OperateAlert.showLangValue(201160);
end

function Lua_AllianceBossWindow:onRemainAddBtnClick()
	if DataCenter.allianceData.leftTimes > 0 then
		OperateAlert.showLangValue(201164);
		return;
	end

	if DataCenter.allianceData.leftBuyTimes <= 0 then
		OperateAlert.showLangValue(201222);
		return;
	end
	self:onShowTip(201165);
end

function Lua_AllianceBossWindow:onShowTip(langValue)
	local totalBuyTime = DataCenter.allianceUtil:getConstConfig("league_boss_buy_times", 1);
	local curBuyTime = totalBuyTime - DataCenter.allianceData.leftBuyTimes + 1;
	local cost = DataCenter.allianceUtil:getConstConfig("league_boss_buy_cost", 5);
	self.remainCost = cost[curBuyTime];
	local tipsData = { des = LanUtil.formateStr(langValue, self.remainCost[1][2], spliceIconStrById(self.remainCost[1][1])), btnType = 1, owner = self, sureFun = self.onRemainAdd };
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_AllianceBossWindow:onRemainAdd()
	local costId = DataCenter.packData:checkConsumeEnough(self.remainCost);
	if costId == nil then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceBossBuyTime();
		if self.dalayFun ~= nil then
			self.dalayFun(self);
		end
	else
		DataCenter.packUtil:openPathWindow(costId);
	end
	self.remainCost = nil;
	self.dalayFun = nil;
end

function Lua_AllianceBossWindow:onRankRewardBtnClick()
	Lua_WindowUtil.openWin("Lua_AllianceBossRankRewardWindow", Lua_WinParam.ACTION_OPEN, DataCenter.allianceData.showId);
end

function Lua_AllianceBossWindow:onHurtDetailBtnClick()
	Lua_WindowUtil.openWin("Lua_AllianceBossHurtRankWindow", Lua_WinParam.ACTION_OPEN, DataCenter.allianceData.showId);
end

function Lua_AllianceBossWindow:onChallengeBtnClick()
	if DataCenter.allianceData.showId < DataCenter.allianceData.topId then
		OperateAlert.showLangValue(201195);
		return;
	end
	if DataCenter.allianceData.leftTimes <= 0 then
		if DataCenter.allianceData.leftBuyTimes > 0 then
			self.dalayFun = self.openScene;
			self:onShowTip(201302);
		else
			OperateAlert.showLangValue(201194);
		end
		return;
	end
	self:openScene();
end

function Lua_AllianceBossWindow:openScene()
	local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_LEAGUEBOSS);
	DataCenter.preLoadData:preShowScene("Lua_FightLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_AllianceBossWindow:onSceneShow(param)
	local list = { template_id = Lua_FightDefine.TEMPLATE_ID_LEAGUEBOSS, monster_player_id = DataCenter.allianceData.bossStageInfo.monster_id };
	Lua_WindowUtil.openWin("Lua_FightLineupWindow", Lua_WinParam.ACTION_OPEN, list);
end

function Lua_AllianceBossWindow:onSweepBtnClick()
	if DataCenter.allianceData.lastHurt <= 0 then
		OperateAlert.showLangValue(201115);
		return;
	end

	if DataCenter.allianceData.leftBlood <= 0 then
		OperateAlert.showLangValue(201195);
		return;
	end

	if DataCenter.allianceData.leftTimes <= 0 then
		if DataCenter.allianceData.leftBuyTimes > 0 then
			self.dalayFun = self.startSweep;
			self:onShowTip(201303);
		else
			OperateAlert.showLangValue(201194);
		end
		return;
	end
	
	local tipsData = {
		des = LanUtil.formateStr(201166, DataCenter.allianceData.lastHurt),
		btnType = 1,
		owner = self,
		sureFun = self.startSweep;
	};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_AllianceBossWindow:startSweep()
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceBossSweep(DataCenter.allianceData.showId, 0);
end

function Lua_AllianceBossWindow:tipIconClick()
	local tipsData = { des = LanUtil.getValue(201202), posX = 170, posY = -170 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_AllianceBossWindow:hide()
	self:superCall("hide");

	if not Lua_WindowUtil.isWindowShowing("Lua_AllianceMainWindow") then
		Lua_WindowUtil.openWin("Lua_AllianceMainWindow", Lua_WinParam.ACTION_OPEN);
	end
end

function Lua_AllianceBossWindow:resetActive(bActive)
    self:superCall("resetActive", bActive);
    if bActive then -- 显示
    	self:updateData();
    else
        if self.modelScenePanel ~= nil then
            self.modelScenePanel:dispose();
            self.modelScenePanel = nil;
        end
    end
end












Lua_AllianceBossItem = class("Lua_AllianceBossItem", Lua_ListCell);

function Lua_AllianceBossItem:ctor(p)
	self:superCall("ctor", p, "AllianceBossItem_skin");
end

function Lua_AllianceBossItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_AllianceBossItem:dispose()
	self:superCall("dispose");
end

function Lua_AllianceBossItem:setData(data)
	self.data = data;

	self.selectIcon:setAltas(data.monsterVo.avatar_atlas_1, data.monsterVo.avatar_sprite_1);
	self.titleTxt.text = LanUtil.formateStr(201154, data.id);
	self:updateData();
end

function Lua_AllianceBossItem:updateData()
	self.lockObj:SetActive(self.data.id > DataCenter.allianceData.topId);

	local isGray = self.data.id < DataCenter.allianceData.topId;
	self.bg:setGray(isGray);
	self.selectIcon:setGray(isGray);
end

function Lua_AllianceBossItem:onPressClick()
	if self.data.id > DataCenter.allianceData.topId then
		OperateAlert.showLangValue(201155);
		return false;
	end

	if self.selected == false then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceBossInfo(self.data.id);
	end
	return true;
end

function Lua_AllianceBossItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);
	self.selectBg:setEnable(bSelect);
end