--联盟系统 联盟挑战伤害排行Window
Lua_AllianceChallengeRankWindow = class("Lua_AllianceChallengeRankWindow", Lua_Window);

function Lua_AllianceChallengeRankWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.showBlackMask = true;

	self.windowName = "Lua_AllianceChallengeRankWindow";
	self.skinName = "AllianceChallengeRankWindow_skin";
end

function Lua_AllianceChallengeRankWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_LEAGUE_CHALLENGE_RANK", self, self.updateData);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceChallengeRankWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	if DataCenter.allianceData.isOpenChallenge then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceChallengeRank(0);
	else
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceChallengeRank(DataCenter.allianceData.challengeType);
	end

	self.dragList = Lua_DragList.new(self.content, 660, 500, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_AllianceChallengeRankItem, 650, 130, 1);
    self.dragList:setLocation(0, -150, 0);
end

function Lua_AllianceChallengeRankWindow:dispose()
	if self.dragList == nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceChallengeRankWindow:updateData(data)
	self.dragList:setArrayData(data);
end




























Lua_AllianceChallengeRankItem = class("Lua_AllianceChallengeRankItem", Lua_ListCell);

function Lua_AllianceChallengeRankItem:ctor(p)
	self:superCall("ctor", p, "AllianceChallengeRankItem_skin");
end

function Lua_AllianceChallengeRankItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setLocation(-100, 0, 0);
end

function Lua_AllianceChallengeRankItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceChallengeRankItem:setData(data)
	self.data = data;
	self.rankTxt.text = data.rank;
	self.nameTxt.text = data.player_name;
	self.hurtTxt.text = data.hurt;

	self.avatarItem:setRoleAvatar(data.head_icon);
end