--联盟系统 奖励预览Window
Lua_AllianceChallengeRewardWindow = class("Lua_AllianceChallengeRewardWindow", Lua_Window);

function Lua_AllianceChallengeRewardWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.winBgPath = "/images/common/ui_common_bg_001.jpg";

	self.windowName = "Lua_AllianceChallengeRewardWindow";
	self.skinName = "AllianceChallengeRewardWindow_skin";
end

function Lua_AllianceChallengeRewardWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceChallengeRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	local data = DataCenter.allianceData.challengeInfo;

	self.challengeRewardList = Lua_ItemIconList.new(self.content);
	self.challengeRewardList:setLocation(-280, 490, 0);
	self.challengeRewardList:setArrayData(data.challenge_reward);
	self.challengeRewardList.canClick = true;

	self.normalRewardList = Lua_ItemIconList.new(self.content);
	self.normalRewardList:setLocation(-280, 345, 0);
	self.normalRewardList:setArrayData(data.kill_fix_reward);
	self.normalRewardList.canClick = true;

	self.randomRewardList = Lua_DragList.new(self.content, 630, 200, Lua_AxisDefine.Vertical);
	self.randomRewardList:setListCell(Lua_AllianceChallengeHurtRewardItem, 620, 130, 1);
    self.randomRewardList:setLocation(0, 260, 0);
    self.randomRewardList:setArrayData(data.kill_rate_reward);

	self.hurtRewardList = Lua_DragList.new(self.content, 630, 200, Lua_AxisDefine.Vertical);
	self.hurtRewardList:setListCell(Lua_AllianceChallengeHurtRewardItem, 620, 130, 1);
    self.hurtRewardList:setLocation(0, -20, 0);
    self.hurtRewardList:setArrayData(data.blood_reward);

	self.rankRewardList = Lua_DragList.new(self.content, 630, 200, Lua_AxisDefine.Vertical);
	self.rankRewardList:setListCell(Lua_AllianceChallengeHurtRewardItem, 620, 130, 1);
    self.rankRewardList:setLocation(0, -280, 0);
    self.rankRewardList:setArrayData(data.rank_reward);
end

function Lua_AllianceChallengeRewardWindow:dispose()
	if self.challengeRewardList == nil then
		self.challengeRewardList:dispose();
		self.challengeRewardList = nil;
	end
	if self.normalRewardList == nil then
		self.normalRewardList:dispose();
		self.normalRewardList = nil;
	end
	if self.randomRewardList == nil then
		self.randomRewardList:dispose();
		self.randomRewardList = nil;
	end
	if self.hurtRewardList == nil then
		self.hurtRewardList:dispose();
		self.hurtRewardList = nil;
	end
	if self.rankRewardList == nil then
		self.rankRewardList:dispose();
		self.rankRewardList = nil;
	end
	self:superCall("dispose");
end





















Lua_AllianceChallengeHurtRewardItem = class("Lua_AllianceChallengeHurtRewardItem", Lua_ListCell);

function Lua_AllianceChallengeHurtRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_AllianceChallengeHurtRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showTxt = UICreate.createLabel(self.content, "", -290, 0, 200, 35, 22);

	self.rewardList = Lua_ItemIconList.new(self.content);
end

function Lua_AllianceChallengeHurtRewardItem:dispose()
	if self.showTxt ~= nil then
		self.showTxt:dispose();
		self.showTxt = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceChallengeHurtRewardItem:setData(data)
	local rewardData;
	if type(data[1]) == "number" and type(data[2]) == "table" then
		self.showTxt.text = data[1] .. "%";
		rewardData = data[2];
	elseif type(data[1]) == "table" and type(data[2]) == "number" then
		self.showTxt.text = data[2] .. "%";
		rewardData = data[1];
	elseif type(data[1]) == "table" and type(data[2]) == "table" then
		self.showTxt.text = data[1][1] .. "-" .. data[1][2];
		rewardData = data[2];
	end
	self.rewardList:setArrayData(rewardData);
end

function Lua_AllianceBossRankRewardItem:onPressClick()
	self.rewardList:onBoundClick();
end