--联盟系统 联盟挑战Window
checkRequire("Lua_AllianceHurtItem");
Lua_AllianceChallengeWindow = class("Lua_AllianceChallengeWindow", Lua_Window);

function Lua_AllianceChallengeWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.showBlackMask = true;

	self.windowName = "Lua_AllianceChallengeWindow";
	self.skinName = "AllianceChallengeWindow_skin";
end

function Lua_AllianceChallengeWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_LEAGUE_CHALLENGE_INFO", self, self.updateData);
	self:addLuaEvent("UPDATE_LEAGUE_CHALLENGE_REWARD", self, self.updateReward);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceChallengeWindow:buildShowItem()
	self:superCall("buildShowItem");

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceChallenge(0);

	self.rankArr = Array();
	local item;
	for i = 1, 3 do
		item = Lua_AllianceHurtItem.new(self.upObj);
		item:setLocation(-320, 565 - (i - 1) * 55, 0);
		item:setRank(i);
		self.rankArr:add(item);
	end

	local bossTypeArr = DataCenter.allianceUtil.getChallengeTypeArr;
	self.minType = bossTypeArr[1];
	self.maxType = bossTypeArr[bossTypeArr:getSize()];

	self.detailTxt:addClickFuntion(self, self.onDeatailTxtClick);
	self.rewardViewTxt:addClickFuntion(self, self.onRewardViewTxtClick);

	self.subIcon:addClickFuntion(self, self.onSubIconClick);
	self.addIcon:addClickFuntion(self, self.onAddIconClick);
	self.openBtn:addClickFuntion(self, self.onOpenBtnClick);
	self.openTipIcon:addClickFuntion(self, self.onOpenTipsClick);

	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
	self.threatBtn:addClickFuntion(self, self.onThreatBtnClick);
	self.sweepBtn:addClickFuntion(self, self.onSweepBtnClick);
end

function Lua_AllianceChallengeWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.onCountDown);
	DataCenter.allianceData.challengeType = nil;
	DataCenter.preLoadData:removeBySign("Lua_FightLineupWindow", self, self.onSceneShow);

	if self.rankArr ~= nil then
		self.rankArr:dispose();
		self.rankArr:clear();
		self.rankArr = nil;
	end
	if self.threatRewardArr ~= nil then
		self.threatRewardArr:dispose();
		self.threatRewardArr = nil;
	end
	if self.showRewardArr ~= nil then
		self.showRewardArr:dispose();
		self.showRewardArr = nil;
	end
	if self.showRewardItem ~= nil then
		self.showRewardItem:dispose();
		self.showRewardItem = nil;
	end
	if self.boxRewardArr ~= nil then
		self.boxRewardArr:dispose();
		self.boxRewardArr = nil;
	end
	if self.modelEffImg ~= nil then
		self.modelEffImg:dispose();
		self.modelEffImg = nil;
	end
	if self.skillArr ~= nil then
		self.skillArr:dispose();
		self.skillArr = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceChallengeWindow:updateData()
	local challengeInfo = DataCenter.allianceData.challengeInfo;
	local list = DataCenter.allianceData.challengeRanklist
	table.sort(list, function(a, b) return a.rank < b.rank end);
	local len = #list;
	for i = 1, 3 do
		if len >= i then
			self.rankArr[i]:setData(data.rankList[i]);
		else
			self.rankArr[i]:setData(nil);
		end
	end

	local hardStr = DataCenter.allianceUtil:getConstConfig("league_challenge_hard_name", 5)
	self.hardTxt.text = LanUtil.formateStr(201196, hardStr[challengeInfo.difficulty_type] .. challengeInfo.difficulty_level);

	local time = DataCenter.roleData.serverTime - DataCenter.allianceData.challengeStartTick;
	if DataCenter.allianceData.isOpenChallenge then
		self.remainBuyTxt.text = LanUtil.formateStr(201162, DataCenter.allianceData.leftBuyTimes);
		-- self.remainTxt.text = LanUtil.formateStr(201163, DataCenter.allianceData.leftFreeTimes);
		self.remainNumTxt.text = DataCenter.allianceData.leftFreeTimes;

		if DataCenter.allianceData.challengeLeftBlood > 0 then
			self.threatBtn:setLangValue(201177);
		else
			self.threatBtn:setLangValue(201178);
		end
		self.sweepBtn:setBtnEnable(DataCenter.allianceData.lastChallengeHurt > 0);

		if self.threatRewardArr == nil then
			self.threatRewardArr = Lua_ItemIconList.new(self.threatObj);
			self.threatRewardArr:setLocation(-233, -298, 0);
			self.threatRewardArr.canClick = true;

			self.showRewardItem = Lua_ItemIcon.new(self.threatObj);
			self.showRewardItem:setLocation(75, -298, 0);
			self.showRewardItem.canClick = true;
		end
		self.threatRewardArr:setArrayData(challengeInfo.challenge_reward);

		local vo = Lua_ToolVo.createToolVo(challengeInfo.single_show_reward[1], challengeInfo.single_show_reward[2]);
		self.showRewardItem:setData(vo);

		time = DataCenter.allianceUtil:getConstConfig("league_challenge_tick", 1) - time;
	else
		local costInfo = DataCenter.allianceUtil:getConstConfig("league_challenge_cost", 5)[1];
		local packNum = DataCenter.packData:getItemCountById(costInfo[1]);
		self.isCanOpenChallenge = packNum >= costInfo[2];
		local str = spliceIconStrById(costInfo[1]);
		self.openCostTxt.text = LanUtil.formateStr(201182, str, packNum, tostring(costInfo[2]));

		if self.showRewardArr == nil then
			self.showRewardArr = Lua_ItemIconList.new(self.startObj);
			self.showRewardArr:setLocation(-235, -300, 0);
			self.showRewardArr:setRectAnchor(7);
			self.showRewardArr.pivot = 1;
		end
		self.showRewardArr:setArrayData(challengeInfo.all_show_reward);	

		time = DataCenter.allianceUtil:getConstConfig("league_challenge_tick", 6) - time;	
	end
	self.startObj:SetActive(not DataCenter.allianceData.isOpenChallenge);
	self.threatObj:SetActive(DataCenter.allianceData.isOpenChallenge);

	self.showTime = time;
	if self.showTime >= 1 then
		self.showTime = self.showTime + 1;
		self:onCountDown();

		if self.isTimer ~= true then
			self.isTimer = true;
			Lua_CommonUtil.addTimer("onCountDown", 1, self, self.onCountDown);
		end
	else
		if not DataCenter.allianceData.isOpenChallenge then
			if self.showTime < 0 then
				self.showTime = 0;
			end
			self.openTimeTxt.text = LanUtil.formateStr(201211, Lua_TimeTransform.transSeconds6(self.showTime, true, true,true));
		end
		self:clearCountDown();
	end

	self:updateBossShow(challengeInfo.monsterData);
	self:updateReward();
end

function Lua_AllianceChallengeWindow:updateBossShow(data)
	self.bossNameTxt.text = data.name;

	if self.modelEffImg == nil then
		self.modelEffImg = UICreate.createModelEffImg(self.content, nil, nil, 0, 210, 400, 400);
		self.modelEffImg.siblingIndex = 1;
		self.modelEffImg:setCamField(1, 1, 100, true);
		self.modelEffImg:setCamPos(0, 1, -10);
		self.modelEffImg:setModelEffDir(180);
		self.modelEffImg.canRot = false;
	end
	self.modelEffImg:setUrl(data.heroVo.modelUrl, data.heroVo.modelSrc);

	if self.skillArr == nil then
		self.skillArr = Array();
	end
	local len = self.skillArr:getSize();
	local skilList = data.use_hero_skill == 1 and data.heroVo.fight_skill or data.skill_list;
	local dataLen = #skilList;
	local maxLen = dataLen > len and dataLen or len;
	local item;
	local posDic = {{-260, -34}, {-107, -139}, {107, -139}, {260, -34}};
	for i = 1, maxLen do
		item = self.skillArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_SkillIconItem.new(self.upObj);
				item:setCanClick(true);
				self.skillArr:add(item);
			else
				item:setEnable(true);
			end
			item:setLocation(posDic[i][1], posDic[i][2], 0);
			item:setSkillId(skilList[i]);
		end
	end
end

function Lua_AllianceChallengeWindow:updateReward()
	if self.boxRewardArr == nil then
		self.boxRewardArr = Array();
	end

	local challengeInfo = DataCenter.allianceData.challengeInfo;
	local len = #challengeInfo.blood_reward;
	local itemNum = self.boxRewardArr:getSize();
	local maxLen = len > itemNum and len or itemNum;
	local item;
	local rewardInfo;
	for i = 1, maxLen do
		if i > itemNum then
			item = Lua_AllianceChallengeBoxItem.new(self.content);
			self.boxRewardArr:add(item);
		else
			item = self.boxRewardArr[i];
		end
		
		if i <= len then
			rewardInfo = challengeInfo.blood_reward[i];
			item:setData(rewardInfo);
			item:setRectAnchor(1);
			item:setLocation(-255 + rewardInfo[1] / 100 * 615, -1132, 0);
			item:setEnable(true);
		else
			item:setEnable(false);
		end
	end

	self.bossBloodBar:setMaxValue(challengeInfo.monsterData.health);
	self.bossBloodBar:setValue(DataCenter.allianceData.challengeLeftBlood);
end

function Lua_AllianceChallengeWindow:onCountDown()
	self.showTime = self.showTime - 1;
	if self.showTime >= 1 then
		if DataCenter.allianceData.isOpenChallenge then
			self.threatTimeTxt.text = Lua_TimeTransform.transSeconds6(self.showTime, true, true,true);
		else
			self.openTimeTxt.text = LanUtil.formateStr(201211, Lua_TimeTransform.transSeconds6(self.showTime, true, true,true));
		end
	else
		self:clearCountDown();
	end
end

function Lua_AllianceChallengeWindow:clearCountDown()
	Lua_CommonUtil.removeTimer(self, self.onCountDown);
	self.isTimer = false;

	if DataCenter.allianceData.isOpenChallenge then
		DataCenter.allianceData.isOpenChallenge = false;
		self:updateData();
	end	
end

function Lua_AllianceChallengeWindow:onDeatailTxtClick(go)
	Lua_WindowUtil.openWin("Lua_AllianceChallengeRankWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_AllianceChallengeWindow:onRewardViewTxtClick(go)
	Lua_WindowUtil.openWin("Lua_AllianceChallengeRewardWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_AllianceChallengeWindow:onSubIconClick(go)
	local index = DataCenter.allianceData.challengeType - 1;
	if index < self.minType then
		index = self.minType;
	end
	self:updateSelect(index);
end

function Lua_AllianceChallengeWindow:onAddIconClick(go)
	local index = DataCenter.allianceData.challengeType + 1;
	if index > self.maxType then
		index = self.maxType;
	end
	self:updateSelect(index);
end

function Lua_AllianceChallengeWindow:updateSelect(index)
	if DataCenter.allianceData.challengeType == index then return end
	DataCenter.allianceData.challengeType = index;
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceChallenge(index);
end

function Lua_AllianceChallengeWindow:onOpenBtnClick(go)
	if self.showTime > 0 then
		OperateAlert.show(LanUtil.formateStr(201181, Lua_TimeTransform.transSeconds6(self.showTime, true, true,true)));
		return;
	end
	if not self.isCanOpenChallenge then
		OperateAlert.showLangValue(201175);
		return;
	end

	local costInfo = DataCenter.allianceUtil:getConstConfig("league_challenge_cost", 5)[1];

	local tipsData = {
		des = LanUtil.formateStr(201176, costInfo[2], DataCenter.allianceData.challengeType),
		btnType = 1,
		owner = self
	};
	tipsData.sureFun = function()
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sOpenAllianceChallenge(DataCenter.allianceData.challengeType);
	end;
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_AllianceChallengeWindow:onOpenTipsClick()
	local tipsData = { des = LanUtil.getValue(201225), isBottomShow = true, posX = 200, posY = 200 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_AllianceChallengeWindow:onBuyBtnClick(go)
	if DataCenter.allianceData.leftFreeTimes > 0 then
		OperateAlert.showLangValue(201164);
		return;
	end

	local totalBuyTime = DataCenter.allianceUtil:getConstConfig("league_challenge_buy_times", 1);
	local curBuyTime = totalBuyTime - DataCenter.allianceData.leftBuyTimes + 1;
	local costNum = DataCenter.allianceUtil:getConstConfig("league_challenge_cost", 5)[1][2] * curBuyTime;

	local tipsData = {
		des = LanUtil.formateStr(201165, costNum),
		btnType = 1,
		owner = self
	};
	tipsData.sureFun = function()
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sbuyAllianceChallengeTime();
	end;
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_AllianceChallengeWindow:onThreatBtnClick(go)
	if DataCenter.allianceData.leftFreeTimes <= 0 then
		OperateAlert.showLangValue(201194);
		return;
	end

	local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_LEAGUECHALLENGE);
	DataCenter.preLoadData:preShowScene("Lua_FightLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_AllianceChallengeWindow:onSceneShow(param)
	Lua_WindowUtil.openWin("Lua_FightLineupWindow", Lua_WinParam.ACTION_OPEN, Lua_FightDefine.TEMPLATE_ID_LEAGUECHALLENGE);
end

function Lua_AllianceChallengeWindow:onSweepBtnClick(go)
	if DataCenter.allianceData.leftFreeTimes <= 0 then
		OperateAlert.showLangValue(201194);
		return;
	end

	local tipsData = {
		des = LanUtil.formateStr(201166, DataCenter.allianceData.lastChallengeHurt),
		btnType = 1,
		owner = self
	};
	tipsData.sureFun = function()
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceChallengeSweep();
	end;
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end






















Lua_AllianceChallengeBoxItem = class("Lua_AllianceChallengeBoxItem", Lua_ListCell);

function Lua_AllianceChallengeBoxItem:ctor(p)
	self:superCall("ctor", p, "AllianceChallengeBoxItem_skin");
end

function Lua_AllianceChallengeBoxItem:buildShowItem()
	self:superCall("buildShowItem");
	self.effectIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
	self.effectIcon.siblingIndex = 1;
	self.boxIcon:addClickFuntion(self, self.onBoxClick);
end

function Lua_AllianceChallengeBoxItem:dispose()
	self:superCall("dispose");
end

function Lua_AllianceChallengeBoxItem:setData(data)
	self.data = data;

	self.rewardState = DataCenter.allianceData.challengeRewardInfo[data[1]];
	if self.rewardState == nil then
		self.boxIcon:setAltas("common_altas_4", "ui_djc_box_002_n");
	elseif self.rewardState == 1 then
		self.boxIcon:setAltas("common_altas_4", "ui_djc_box_002_n");
	elseif self.rewardState == 2 then
		self.boxIcon:setAltas("common_altas_4", "ui_djc_box_002_p");
	end
	if self.rewardState == 1 then
		self.effectIcon:setEnable(true);
		self.effectIcon:setAltas("common_altas_4", "ui_djc_box_002_n_t");
	else
		self.effectIcon:setEnable(false);
	end
	self.txt.text = data[1] .. "%";
end

function Lua_AllianceChallengeBoxItem:onBoxClick()
	if self.rewardState == 1 then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceChallengeReward(self.data[1]);
	else
		Lua_WindowUtil.openWin("Lua_RewardPreviewWindow", Lua_WinParam.ACTION_OPEN, { itemList = self.data[2], posX = self.posX, posY = self.posY });
    end
end