--公会对抗 伤害日志界面
Lua_AllianceDuelLogWindow = class("Lua_AllianceDuelLogWindow", Lua_Window);

function Lua_AllianceDuelLogWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;
	
	self.windowName = "Lua_AllianceDuelLogWindow";
	self.skinName = "AllianceDuelLogWindow_skin";
end

function Lua_AllianceDuelLogWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_LEAGUE_DUEL_LOG", self, self.updateData);
	self:addLuaEvent("CHECK_LEAGUE_DUE_LOG", self, self.checkRob);
	self:addLuaEvent("UPDATE_LEAGUE_DUEL_ROB_INFO", self, self.startRob);
end

function Lua_AllianceDuelLogWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 628, 620, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_AllianceDuelLogItem, 628, 131, 1);
	self.dragList:setCellSpacing(0, 8);
    self.dragList:setLocation(0, -50, 0);

    local arr = Array();
	arr:add({_type = 1, nameStr = LanUtil.getValue(201278)});
	arr:add({_type = 2, nameStr = LanUtil.getValue(201279)});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(0, -448, 0);
	self.btnList:setButtonCell(Lua_AllianceDuelLogBtnItem);
	self.btnList:setButtonItem(160, 58);
	self.btnList:setData(arr);
	self.btnList:setClickCallBack(self, self.onBtnClick)
	self.btnList:setSelected(1);

	self.logRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.LeagueCompeteLog);
	self.logRedPoint:setLocation(156, -423, 0);
end

function Lua_AllianceDuelLogWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	DataCenter.preLoadData:removeBySign("Lua_LeagueDuelLineupWindow", self, self.onSceneShow);
	self:superCall("dispose");
end

function Lua_AllianceDuelLogWindow:onBtnClick(index, data)
	if self.index ~= nil and self.index == index then return end
	self.index = index;

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteLog(data._type);

	if self.index == 2 then
		self.logRedPoint:clickHandler();
	end
end

function Lua_AllianceDuelLogWindow:updateData()
	local isShow = #DataCenter.allianceData.competeLogList <= 0;
	self.noneImg:setEnable(isShow);
	self.noneTxt:setEnable(isShow);

	self.dragList:setArrayData(DataCenter.allianceData.competeLogList);
	self.dragList:moveToIndex(1, true);
end

function Lua_AllianceDuelLogWindow:resetActive(bActive)
	self:superCall("resetActive", bActive);

	if bActive then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteLog(self.index);
	end
end

function Lua_AllianceDuelLogWindow:checkRob(data)
	if self.checkData == nil then
		self.checkData = data;
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteRob(data.role_id);
	end
end

function Lua_AllianceDuelLogWindow:startRob(msg)
	-- result: 0:成功 1：对方离开公会 2：伤害已抢完 3:今日未有伤害
	if msg.result == 0 then
		if self.checkData == nil or Lua_WindowUtil.isOpenWin("Lua_LeagueDuelLineupWindow") then return end

		local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_LEAGUEDUELROB);
		DataCenter.preLoadData:preShowScene("Lua_LeagueDuelLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
	elseif msg.result == 1 then
		OperateAlert.showLangValue(201295);
	elseif msg.result == 2 then
		OperateAlert.showLangValue(201296);
	elseif msg.result == 3 then
		OperateAlert.showLangValue(201280);
	end
end

function Lua_AllianceDuelLogWindow:onSceneShow(param)
	local roleId = self.checkData.role_id;
	if tonumber(tostring(roleId)) == DataCenter.roleData.roleId then
		roleId = self.checkData.match_role_id;
	end
	local list = { template_id = Lua_FightDefine.TEMPLATE_ID_LEAGUEDUELROB, enemyId = roleId, enemyFlag = self.checkData.server_flag };
	Lua_WindowUtil.openWin("Lua_LeagueDuelLineupWindow", Lua_WinParam.ACTION_OPEN, list);
	self.checkData = nil;
end















Lua_AllianceDuelLogItem = class("Lua_AllianceDuelLogItem", Lua_ListCell);

function Lua_AllianceDuelLogItem:ctor(p)
	self:superCall("ctor", p, "AllianceDuelLogItem_skin");
end

function Lua_AllianceDuelLogItem:buildShowItem()
	self:superCall("buildShowItem");

	self.robBtn:addClickFuntion(self, self.onRobBtnClick);
end

function Lua_AllianceDuelLogItem:dispose()
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDuelLogItem:setData(data)
	self.data = data;

	self.timeTxt.text = Lua_TimeTransform.transSeconds7(data.tick);
	self.contentTxt.text = data.content;

	local isShow = (data.type == 2 or data.type == 6) and tonumber(tostring(data.role_id)) ~= DataCenter.roleData.roleId;
	if DataCenter.allianceData.competeStage == 1 and DataCenter.allianceData.isDailyHurt and DataCenter.allianceData.competeGrabNum > 0 and data.left_be_grab_times > 0 then
		if data.type == 6 then
			self.robBtn:setAltas("alliance_atlas_1", "xui_ghdk_btn_4_n");
		elseif data.type == 2 then
			self.robBtn:setAltas("alliance_atlas_1", "xui_ghdk_btn_5_n");
		end
		self.robBtn:setEnable(isShow);
		self:updateRedPoint(isShow);	
	else
		if data.type == 6 then
			self.robBtn:setAltas("alliance_atlas_1", "xui_ghdk_btn_4_d");
		elseif data.type == 2 then
			self.robBtn:setAltas("alliance_atlas_1", "xui_ghdk_btn_5_d");
		end
		self.robBtn:setEnable(isShow);
		self:updateRedPoint(false);		
	end
end

function Lua_AllianceDuelLogItem:updateRedPoint(val)
	if val then
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content);
			self.redPointIcon:createRedPointEff();
			self.redPointIcon:setLocation(280, 20);
		end
		self.redPointIcon:updateRedPointShow(true);
	else
		if self.redPointIcon ~= nil then
			self.redPointIcon:updateRedPointShow(false);
		end
	end
end

function Lua_AllianceDuelLogItem:onRobBtnClick()
	local allianceData = DataCenter.allianceData;
	if allianceData.competeStage == 2 then
		OperateAlert.showLangValue(201273);
		return;
	end
	if not allianceData.isDailyHurt then
		OperateAlert.showLangValue(201294);
		return;
	end
	if allianceData.competeGrabNum <= 0 then
		OperateAlert.showLangValue(201293);
		return;
	end
	if self.data.left_be_grab_times <= 0 then
		OperateAlert.showLangValue(201281);
		return;
	end
	Lua_MsgUtil.callFunc("CHECK_LEAGUE_DUE_LOG", self.data);
end



















Lua_AllianceDuelLogBtnItem = class("Lua_AllianceDuelLogBtnItem", Lua_ButtonCell);

function Lua_AllianceDuelLogBtnItem:ctor(p)
	self:superCall("ctor", p, "AllianceDuelLogBtnItem_skin");
end

function Lua_AllianceDuelLogBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnIcon:addClickFuntion(self, self.onPressClick);
	self.btnIcon.clickScale = false;
end

function Lua_AllianceDuelLogBtnItem:dispose()
	self:superCall("dispose");
end

function Lua_AllianceDuelLogBtnItem:setCanClick(val)
	if val == true then
		self.btnIcon.mouseEnable = true
	else
		self.btnIcon.mouseEnable = false
	end
end

function Lua_AllianceDuelLogBtnItem:setData(data)
    self.data = data;
end

function Lua_AllianceDuelLogBtnItem:setSelected(index)
	if self.index == index then
		self.btnTxt.text = LanUtil.formateStr(201282, self.data.nameStr);
		self.btnIcon.alpha = 1;
	else
		self.btnTxt.text = LanUtil.formateStr(201283, self.data.nameStr);
		self.btnIcon.alpha = 0;
	end
end