--公会对抗 排行Panel
Lua_AllianceDuelRankPanel = class("Lua_AllianceDuelRankPanel", Lua_DisplayObject);

function Lua_AllianceDuelRankPanel:ctor(p)
	self:superCall("ctor", p, "AllianceDuelRankPanel_skin");
end

function Lua_AllianceDuelRankPanel:buildPanel()
	self:superCall("buildPanel");

	self:addLuaEvent("UPDATE_LEAGUE_DUEL_RANK", self, self.updateData);
end

function Lua_AllianceDuelRankPanel:buildShowItem()
	self:superCall("buildShowItem");

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteHurt(0);

	self.bg:SetDimensions(720, 433 + self.adaptHeight);

	self.rankArr = Array();
	self.avatarPosList = {{0, -255, 0}, {-236, -270, 0}, {236, -270, 0}};

	self.dragList = Lua_DragList.new(self.content, 688, 420 + self.adaptHeight, Lua_AxisDefine.Vertical)
	self.dragList:setLocation(0, -115, 0)
	self.dragList:setListCell(Lua_AllianceDuelRankItem, 688, 125, 1)
	self.dragList:setCellSpacing(0, 5)
	self.dragList.callBackOwner = self
	self.dragList.turnPageCallBack = self.addPage;
end

function Lua_AllianceDuelRankPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDuelRankPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.bg:SetDimensions(720, 433 + adaptHeight);
	self.dragList:setContentRect(688, 420 + self.adaptHeight);
end

function Lua_AllianceDuelRankPanel:addPage()
	if DataCenter.allianceData.isPageEnd then return end
	
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteHurt(1);
end

function Lua_AllianceDuelRankPanel:updateData()
	local data = DataCenter.allianceData;
	local allianceUtil = DataCenter.allianceUtil;

	local rankInfo;
	local noneSp;
	local nameTxt;
	local valueTxt;
	local serverTxt;
	local avatarStr;
	local numImgStr;
	for i = 1, 2 do
		rankInfo = i == 1 and data.competeUsInfo or data.competeMatchInfo;
		noneSp = "noneRankSp_" .. i;
		nameTxt = "leagueNameTxt_" .. i;
		valueTxt = "leagueValueTxt_" .. i;
		serverTxt = "leagueServerNameTxt_" .. i;
		avatarStr = "leagueAvatarItem_" .. i;
		numImgStr = "leagueNumImg_" .. i;
		if rankInfo.rank == 0 then
			self[noneSp]:setEnable(true);
			if self[numImgStr] ~= nil then
				self[numImgStr]:setEnable(false);
			end
		else
			self[noneSp]:setEnable(false);
			if self[numImgStr] == nil then
				self[numImgStr] = Lua_NumberImage.new(self.content);
				self[numImgStr].pivot = 0;
				self[numImgStr].numOffsetX = -5;
				self[numImgStr].numAtlas = "number";
				self[numImgStr].preStr = "xui_phb_number_";
				self[numImgStr]:setLocation(-275, 308 - (i - 1) * 130, 0);
				self[numImgStr]:setRectAnchor(7);
			end
			self[numImgStr].num = rankInfo.rank;
			self[numImgStr]:setEnable(true);
		end

		if rankInfo.league_id == 0 then
			self[valueTxt].text = "";
			self[serverTxt].text = "";
		else
			self[valueTxt].text = allianceUtil:transNumber(rankInfo.total_hurt, false);
			if DataCenter.allianceData.isOpenKuafu and rankInfo.server_prev ~= "" then
				self[serverTxt].text = LanUtil.formateStr(201163, rankInfo.server_prev);
			end
		end

		self[nameTxt].text = rankInfo.league_name;
		if self[avatarStr] == nil then
			self[avatarStr] = Lua_AvatarItem.new(self.content);
			self[avatarStr]:setLocation(-145, 308- (i - 1) * 130, 0);
			self[avatarStr]:setRectAnchor(7);
		end
		self[avatarStr]:setLeagueAvatar(DataCenter.allianceUtil:getAllianceHeadByIndex(rankInfo.league_head, 1), 0.9);
	end

	for i = 1, #data.competeHurtList do
		self.rankArr:add(data.competeHurtList[i]);
	end

	local isNone = self.rankArr:getSize() <= 3;
	self.noneImg:setEnable(isNone);
	self.noneTxt:setEnable(isNone);

	local titleTxt;
	for i = 1, 3 do
		rankInfo = self.rankArr[i];
		nameTxt = "nameTxt_" .. i;
		titleTxt = "titleTxt_" .. i;
		valueTxt = "valueTxt_" .. i;
		serverTxt = "serverNameTxt_" .. i;
		avatarStr = "avatarItem_" .. i;
		if rankInfo == nil then
			self[titleTxt]:setEnable(false);
			self[nameTxt].text = "";
			self[valueTxt].text = "";
			self[serverTxt].text = "";
			if self[avatarStr] ~= nil then
				self[avatarStr]:setEnable(false);
			end
		else
			self[titleTxt]:setEnable(true);
			self[nameTxt].text = rankInfo.league_name;
			self[valueTxt].text = allianceUtil:transNumber(rankInfo.total_hurt, false);
			if DataCenter.allianceData.isOpenKuafu then
				self[serverTxt].text = LanUtil.formateStr(201163, rankInfo.server_prev);
			end
			if self[avatarStr] == nil then
				self[avatarStr] = Lua_AvatarItem.new(self.content);
				self[avatarStr]:setLocation(self.avatarPosList[i][1], self.avatarPosList[i][2], self.avatarPosList[i][3]);
				self[avatarStr]:setRectAnchor(1);
			end
			self[avatarStr]:setLeagueAvatar(DataCenter.allianceUtil:getAllianceHeadByIndex(rankInfo.league_head, 1), 0.9);
			self[avatarStr]:setEnable(true);
		end
	end
	self.dragList:setArrayData(self.rankArr, 4);
	self.dragList.isPageEnd = DataCenter.allianceData.isPageEnd;
end




















Lua_AllianceDuelRankItem = class("Lua_AllianceDuelRankItem", Lua_ListCell);

function Lua_AllianceDuelRankItem:ctor(p)
	self:superCall("ctor", p, "AllianceDuelRankItem_skin");
end

function Lua_AllianceDuelRankItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setLocation(-145, 0, 0);
end

function Lua_AllianceDuelRankItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil
	end
	self:superCall("dispose");
end

function Lua_AllianceDuelRankItem:setData(data)
	self.data = data;

	self.numTxt.text = data.rank;
	if DataCenter.allianceData.isOpenKuafu then
		self.flagTxt.text = LanUtil.formateStr(201163, data.server_prev);
	end
	self.nameTxt.text = data.league_name;
	self.avatarItem:setLeagueAvatar(DataCenter.allianceUtil:getAllianceHeadByIndex(data.league_head, 1), 0.9);

	local allianceUtil = DataCenter.allianceUtil;
	self.valueTxt.text = allianceUtil:transNumber(data.total_hurt, false);
	-- self.hurtTxt.text = LanUtil.formateStr("({1})", allianceUtil:transNumber(data.daily_hurt));
end