--公会对抗 奖励Panel
Lua_AllianceDuelRewardPanel = class("Lua_AllianceDuelRewardPanel", Lua_DisplayObject);

function Lua_AllianceDuelRewardPanel:ctor(p)
	self:superCall("ctor", p, "AllianceDuelRewardPanel_skin");
end

function Lua_AllianceDuelRewardPanel:buildPanel()
	self:superCall("buildPanel");

	self:addLuaEvent("UPDATE_LEAGUE_DUEL_INFO", self, self.updateData);
end

function Lua_AllianceDuelRewardPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 688, 610 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_AllianceDuelRewardItem, 688, 120, 1);
	self.dragList:setCellSpacing(0, 8);
	self.dragList:setLocation(0, -30, 0);

	local arr = Array();
	arr:add({_type = 1, nameStr = LanUtil.getValue(201284)});
	arr:add({_type = 2, nameStr = LanUtil.getValue(201285)});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(0, 160, 0);
	self.btnList:setButtonCell(Lua_AllianceDuelRewardBtnItem);
	self.btnList:setButtonItem(160, 58);
	self.btnList:setData(arr);
	self.btnList:setClickCallBack(self, self.onBtnClick)
	self.btnList:setSelected(1);
end

function Lua_AllianceDuelRewardPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.myNumImage ~= nil then
		self.myNumImage:dispose();
		self.myNumImage = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDuelRewardPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.dragList:setContentRect(688, 610 + adaptHeight);
end

function Lua_AllianceDuelRewardPanel:onBtnClick(index, data)
	if self.index ~= nil and self.index == index then return end
	self.index = index;

	self:updateData();
end

function Lua_AllianceDuelRewardPanel:updateData()
	local data = DataCenter.allianceData;
	local allianceUtil = DataCenter.allianceUtil;

	local myRankInfo = self.index == 1 and data.competeUsInfo or data.competeMyRank;
	if myRankInfo.rank == 0 then
		self.noneTxt:setEnable(true);
		if self.myNumImage ~= nil then
			self.myNumImage:setEnable(false);
		end
		if self.rewardList ~= nil then
			self.rewardList:setEnable(false);
		end
	else
		self.noneTxt:setEnable(false);
		if self.myNumImage == nil then
			self.myNumImage = Lua_NumberImage.new(self.content);
			self.myNumImage.pivot = 0;
			self.myNumImage.numAtlas = "number"
			self.myNumImage.preStr = "xui_phb_number_";
			self.myNumImage:setLocation(-290, 290, 0);
			self.myNumImage:setRectAnchor(7);
		end
		self.myNumImage:setEnable(true);
		self.myNumImage.num = myRankInfo.rank;

		if self.rewardList == nil then
			self.rewardList = Lua_ItemIconList.new(self.content);
			self.rewardList.pivot = 1;
			self.rewardList:setLocation(-160, 292, 0);
			self.rewardList:setRectAnchor(7);
			self.rewardList:setLayout(140, 130, 999);
			self.rewardList.canClick = true;
			self.rewardList.scaleVal = 0.72;
		end
		self.rewardList:setEnable(true);
		self.rewardList:setArrayData(allianceUtil:getCompeteReward(self.index, myRankInfo.rank));
	end

	local rewardInfo = self.index == 1 and allianceUtil.getCompeteLeagueRewardConfig or allianceUtil.getCompeteRewardConfig;
	self.dragList:setArrayData(rewardInfo);

	if DataCenter.allianceData.competeStage == 1 then
		self:starTimer();
	else
		self:endTimer();
	end
	
end

function Lua_AllianceDuelRewardPanel:starTimer()
	if not self.timer then
		self.timer = true;
		self:onTimer();
		self:addTimer("onTimer", 1, self, self.onTimer);
	end
end

function Lua_AllianceDuelRewardPanel:endTimer()
	if self.timer then
		self.timer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_AllianceDuelRewardPanel:onTimer()
	local time = DataCenter.allianceData.competeEndTick - DataCenter.roleData.serverTime;
	if time < 0 then
		time = 0;
		self:endTimer();
	end 
	self.timeTxt.text = LanUtil.formateStr(201286, Lua_TimeTransform.transSeconds1(time, true, true, true));
end

















Lua_AllianceDuelRewardItem = class("Lua_AllianceDuelRewardItem", Lua_ListCell);

function Lua_AllianceDuelRewardItem:ctor(p)
	self:superCall("ctor", p, "AllianceDuelRewardItem_skin");
end

function Lua_AllianceDuelRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_ItemIconList.new(self.content);
	self.rewardList.pivot = 1;
	self.rewardList:setLocation(-160, 0, 0);
	self.rewardList:setLayout(140, 130, 999);
	self.rewardList.canClick = true;
	self.rewardList.scaleVal = 0.72;
end

function Lua_AllianceDuelRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDuelRewardItem:setData(data)
	self.data = data;

	if data.id <= 3 then
		self.rankSp:setAltas("common_altas_4", "xui_jys_label_" .. (9 + data.id));
	else
		local str = data.rank_range[1];
		if data.rank_range[2] ~= nil and data.rank_range[1] ~= data.rank_range[2] then
			if str > 10 then
				str = str .. "-\n" .. data.rank_range[2];
			else
				str = str .. "-" .. data.rank_range[2];
			end
		end
		self.rankTxt.text = str;
	end
	self.rankSp:setEnable(data.id <= 3);
	self.rankBg:setEnable(data.id > 3);
	self.rankTxt:setEnable(data.id > 3);

	self.rewardList:setArrayData(data.reward);
end












Lua_AllianceDuelRewardBtnItem = class("Lua_AllianceDuelRewardBtnItem", Lua_ButtonCell);

function Lua_AllianceDuelRewardBtnItem:ctor(p)
	self:superCall("ctor", p, "AllianceDuelRewardBtnItem_skin");
end

function Lua_AllianceDuelRewardBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnIcon:addClickFuntion(self, self.onPressClick);
	self.btnIcon.clickScale = false;
end

function Lua_AllianceDuelRewardBtnItem:dispose()
	self:superCall("dispose");
end

function Lua_AllianceDuelBtnItem:setCanClick(val)
	if val == true then
		self.btnIcon.mouseEnable = true
	else
		self.btnIcon.mouseEnable = false
	end
end

function Lua_AllianceDuelRewardBtnItem:setData(data)
    self.data = data;
end

function Lua_AllianceDuelRewardBtnItem:setSelected(index)
	if self.index == index then
		self.btnTxt.text = LanUtil.formateStr("<color=#8f5123>{1}</color>", self.data.nameStr);
		self.btnIcon.alpha = 1;
	else
		self.btnTxt.text = LanUtil.formateStr("<color=#eee8ea>{1}</color>", self.data.nameStr);
		self.btnIcon.alpha = 0;
	end
end