--公会对抗 抢夺界面
Lua_AllianceDuelRobWindow = class("Lua_AllianceDuelRobWindow", Lua_Window);

function Lua_AllianceDuelRobWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER

	self.windowName = "Lua_AllianceDuelRobWindow";
	self.skinName = "AllianceDuelRobWindow_skin";
end

function Lua_AllianceDuelRobWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_LEAGUE_DUEL_HURT", self, self.updateData);
	self:addLuaEvent("CHECK_LEAGUE_DUE_ROB", self, self.checkRob);
	self:addLuaEvent("UPDATE_LEAGUE_DUEL_ROB_INFO", self, self.startRob);
end

function Lua_AllianceDuelRobWindow:buildShowItem()
	self:superCall("buildShowItem");

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteRank(2);

	self.dragList = Lua_DragList.new(self.content, 629, 740, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_AllianceDuelRobItem, 629, 120, 1);
	self.dragList:setCellSpacing(0, 8);
	self.dragList:setLocation(0, -100, 0);
end

function Lua_AllianceDuelRobWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	DataCenter.preLoadData:removeBySign("Lua_LeagueDuelLineupWindow", self, self.onSceneShow);
	self:superCall("dispose");
end

function Lua_AllianceDuelRobWindow:updateData()
	local isShow = #DataCenter.allianceData.competeRankList <= 0;
	self.noneImg:setEnable(isShow);
	self.noneTxt:setEnable(isShow);

	self.dragList:setArrayData(DataCenter.allianceData.competeRankList);
end

function Lua_AllianceDuelRobWindow:checkRob(data)
	if self.checkData == nil then
		self.checkData = data;
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteRob(data.id);
	end
end

function Lua_AllianceDuelRobWindow:startRob(msg)
	-- result: 0:成功 1：对方离开公会 2：伤害已抢完 3:今日未有伤害
	if msg.result == 0 then
		if self.checkData == nil or Lua_WindowUtil.isOpenWin("Lua_LeagueDuelLineupWindow") then return end

		local vo = DataCenter.heroLineupData:getLineupVo(Lua_HeroUtil.LINEUP_LRAGUEDUEL_ATTACK);
		local force = DataCenter.heroLineupData:calcLineupForce(Lua_HeroUtil.LINEUP_LRAGUEDUEL_ATTACK, vo:getStandArr(1));
		local ratioValue = getPreciseDecimal(self.checkData.force / force, 2);
		if ratioValue > 1.25 then
			local tipsData = {
				btnType = 1,
				onFunType = 0,
				des = LanUtil.getValue(201287),
				cancelLabel = LanUtil.getValue(201288);
				sureLabel = LanUtil.getValue(201289);
				owner = self;
				sureFun = self.onFightClick;
				cancelFun = self.onCancelClick;
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
			return;
		end
		self:onFightClick();
	elseif msg.result == 1 then
		OperateAlert.showLangValue(201295);
	elseif msg.result == 2 then
		OperateAlert.showLangValue(201296);
	elseif msg.result == 3 then
		OperateAlert.showLangValue(201280);
	end
end

function Lua_AllianceDuelRobWindow:onCancelClick()
	self.checkData = nil;
end

function Lua_AllianceDuelRobWindow:onFightClick()
	local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_LEAGUEDUELROB);
	DataCenter.preLoadData:preShowScene("Lua_LeagueDuelLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_AllianceDuelRobWindow:onSceneShow(param)
	local list = { template_id = Lua_FightDefine.TEMPLATE_ID_LEAGUEDUELROB, enemyId = self.checkData.id, enemyFlag = self.checkData.server_flag };
	Lua_WindowUtil.openWin("Lua_LeagueDuelLineupWindow", Lua_WinParam.ACTION_OPEN, list);
	self.checkData = nil;
end


















Lua_AllianceDuelRobItem = class("Lua_AllianceDuelRobItem", Lua_ListCell);

function Lua_AllianceDuelRobItem:ctor(p)
	self:superCall("ctor", p, "AllianceDuelRobItem_skin");
end

function Lua_AllianceDuelRobItem:buildShowItem()
	self:superCall("buildShowItem");

	self.robBtn:addClickFuntion(self, self.onRobBtnClick);
end

function Lua_AllianceDuelRobItem:dispose()
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDuelRobItem:setData(data)
	self.data = data;

	if data.rank <= 3 then
		self.rankSp:setAltas("common_altas_4", "xui_jys_label_" .. (9 + data.rank));
	else
		self.rankTxt.text = data.rank;
	end
	self.rankSp:setEnable(data.rank <= 3);
	self.rankBg:setEnable(data.rank > 3);
	self.rankTxt:setEnable(data.rank > 3);

	self.nameTxt.text = data.name;
	self.fightTxt.text = DataCenter.allianceUtil:transNumber(data.force, false);
	self.hurtTxt.text = DataCenter.allianceUtil:transNumber(data.total_hurt, false);
	self.addTxt.text = LanUtil.formateStr("({1})", DataCenter.allianceUtil:transNumber(data.daily_hurt));

	if DataCenter.allianceData.isDailyHurt and DataCenter.allianceData.competeGrabNum > 0 and data.left_be_grab_times > 0 then
		self.robBtn:setAltas("alliance_atlas_1", "xui_ghdk_btn_4_n");
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content);
			self.redPointIcon:createRedPointEff();
			self.redPointIcon:setLocation(280, 20);
		end
		self.redPointIcon:updateRedPointShow(true);
	else
		self.robBtn:setAltas("alliance_atlas_1", "xui_ghdk_btn_4_d");
		if self.redPointIcon ~= nil then
			self.redPointIcon:updateRedPointShow(false);
		end
	end
end

function Lua_AllianceDuelRobItem:onRobBtnClick()
	if not DataCenter.allianceData.isDailyHurt then
		OperateAlert.showLangValue(201294);
		return;
	end
	if DataCenter.allianceData.competeGrabNum <= 0 then
		OperateAlert.showLangValue(201293);
		return;
	end
	if self.data.left_be_grab_times <= 0 then
		-- OperateAlert.showLangValue(201280);
		OperateAlert.show("此伤害记录被抢夺次数已达上限");
		return;
	end
	Lua_MsgUtil.callFunc("CHECK_LEAGUE_DUE_ROB", self.data);
end