--公会对抗主界面
Lua_AllianceDuelWindow = class("Lua_AllianceDuelWindow", Lua_Window);

function Lua_AllianceDuelWindow:ctor()
	self:superCall("ctor");

	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;
	self.isSingleShowWin = true;
	self.blackAlpha = 0.01;
	self.layer = MainWinDefine.MAIN_MENU_TOP_LAYER;

	self.windowName = "Lua_AllianceDuelWindow";
	self.skinName = "AllianceDuelWindow_skin";
end

function Lua_AllianceDuelWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_LEAGUE_DUEL_INFO", self, self.updateModelShow);
end

function Lua_AllianceDuelWindow:buildShowItem()
	self:superCall("buildShowItem");

	-- 设置默认阵容
	local lineTypeList = { Lua_HeroUtil.LINEUP_LRAGUEDUEL_ATTACK, Lua_HeroUtil.LINEUP_LRAGUEDUEL_DEFENSIZE };
	local mainLineupVo = DataCenter.heroLineupData:getLineupVo(Lua_HeroUtil.LINEUP_MAIN_TYPE);
	local lineupVo;
	for i = 1, #lineTypeList do
		lineupVo = DataCenter.heroLineupData:getLineupVo(lineTypeList[i]);
		if lineupVo:getHeroNumByLineupIdx(1) <= 0 and mainLineupVo:getHeroNumByLineupIdx(1) > 0 then
			Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroSaveLineup(lineTypeList[i], mainLineupVo.localStandTypeDic, mainLineupVo.localLineupDic, mainLineupVo.localArtifactDic);
		end
	end

	self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content);
	self.roleInfoPanel:setRectAnchor(1);
	
	local btnInfoArr = Array();
	btnInfoArr:add({iconIdx = 1, panelStr = "Lua_AllianceDuelPanel"});
	btnInfoArr:add({iconIdx = 3, panelStr = "Lua_AllianceDuelRankPanel"});
	btnInfoArr:add({iconIdx = 5, panelStr = "Lua_AllianceDuelRewardPanel"});
	btnInfoArr:add({iconIdx = 4, pathId = 1058});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(145, 60, 0);
	self.btnList.pivot = -1;
	self.btnList:setButtonCell(Lua_AllianceDuelBtnItem);
	self.btnList:setButtonLine("common_altas_1", "xui_common_line_001", 2, 115, 0, 0, 1);
	self.btnList:setButtonItem(108, 118);
	self.btnList:setData(btnInfoArr);
	self.btnList:setClickCallBack(self, self.onBtnClick)
	self.btnList:setSelected(1);
end

function Lua_AllianceDuelWindow:dispose()
	if self.roleInfoPanel then
		self.roleInfoPanel:dispose();
		self.roleInfoPanel = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	if self.modelScenePanel then
		self.modelScenePanel:dispose();
		self.modelScenePanel = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDuelWindow:showWin(param)
	self:superCall("showWin", param);

	if param.modelScenePanel then
		self.modelScenePanel = param.modelScenePanel
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
		param.modelScenePanel = nil
	end
end

function Lua_AllianceDuelWindow:onBtnClick(index, data)
	if self.index ~= nil and self.index == index then return end
	self.index = index;

	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	if data.panelStr ~= nil then
		local showPanel = checkRequire(data.panelStr);
		self.curPanel = showPanel.new(self.content);
		self.curPanel:setSiblingIndex(0);
		self.curPanel:setRectAnchor(9);

		if self.modelScenePanel ~= nil then
			self.modelScenePanel.rotBg:setEnable(index == 1);
		end
	else
		DataCenter.funcPathUtil:gotoFunction(data.pathId);
		self:hide();
	end
end

function Lua_AllianceDuelWindow:resetActive(bActive)
	self:superCall("resetActive", bActive);
	self:updateModelShow();
end

function Lua_AllianceDuelWindow:updateModelShow()
	if self.bActive then
		if self.modelScenePanel == nil then
			self.modelScenePanel = Lua_ModelScenePanel.new();
			self.modelScenePanel:setParent(self.content)
			self.modelScenePanel:setRotBgDimensions(550, 600)
			self.modelScenePanel:setRotBgPos(0, 195)
		end

		if self.bInitModel or not self.modelScenePanel.bShowModel then
			local monsterConfig = Lua_MonsterPlayerConfigData.getConfigData(DataCenter.allianceData.competeBossId);
			local monsterData = Lua_MonsterConfigData.getMonsterConfig(monsterConfig.fighter_list[1][1][1]);
			local data = monsterData.heroVo;

			self.modelScenePanel:setModelDir(data.uiModelDir);
			self.modelScenePanel:setModelScale(data.uiModelScale);
			self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, data.poseActEffs);
			self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, data.showActEffs);

			if DataCenter.allianceData.competeStage == 1 and DataCenter.allianceData.competeJoinType == 1 then
				self.modelScenePanel:showModelScene(Lua_SceneDefine.LEAGUE_DUEL_BOSS, data.uiModelUrl, data.uiModelAvatarName, data.uiModelCamController, true);
				self.modelScenePanel:setModelAct(data.uiShowAct, Lua_ThingDefine.UIWAIT, true);
			else
				self.modelScenePanel:showModelScene(Lua_SceneDefine.LEAGUE_DUEL_BOSS);
			end

			self.bInitModel = true
		end
	else
		if self.modelScenePanel then
			self.modelScenePanel:dispose();
			self.modelScenePanel = nil;
		end
	end
end

function Lua_AllianceDuelWindow:hide()
	self:superCall("hide");

	if not Lua_WindowUtil.isWindowShowing("Lua_AllianceMainWindow") then
		Lua_WindowUtil.openWin("Lua_AllianceMainWindow", Lua_WinParam.ACTION_OPEN);
	end
end














Lua_AllianceDuelBtnItem = class("Lua_AllianceDuelBtnItem", Lua_ButtonCell);

function Lua_AllianceDuelBtnItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_AllianceDuelBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnIcon = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 0, 0);
	self.btnIcon:addClickFuntion(self, self.onPressClick);
	self.btnIcon.clickScale = false;
end

function Lua_AllianceDuelBtnItem:dispose()
	if self.btnIcon ~= nil then
		self.btnIcon:dispose();
		self.btnIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceDuelBtnItem:setCanClick(val)
	if val == true then
		self.btnIcon.mouseEnable = true
	else
		self.btnIcon.mouseEnable = false
	end
end

function Lua_AllianceDuelBtnItem:setData(data)
    self.data = data;
end

function Lua_AllianceDuelBtnItem:setSelected(index)
	local idx = self.data.iconIdx == 1 and DataCenter.allianceData.competeStage or self.data.iconIdx;
	if index == self.index then
		self.btnIcon:setAltas("alliance_atlas_3", "xui_ghdk_zgnbutton_" .. idx .."_p")
	else
		self.btnIcon:setAltas("alliance_atlas_3", "xui_ghdk_zgnbutton_" .. idx .."_n")
	end
end