--联盟系统 联盟成长Window
Lua_AllianceGrowUpWindow = class("Lua_AllianceGrowUpWindow", Lua_Window);
function Lua_AllianceGrowUpWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.showBlackMask = true;

	self.windowName = "Lua_AllianceGrowUpWindow";
	self.skinName = "AllianceGrowUpWindow_skin";
end

function Lua_AllianceGrowUpWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_LEAGUE_GROWUPINFO", self, self.updateData);
	self:addLuaEvent("UPDATE_LEAGUE_LEVELREWARD", self, self.updateLevelReward);
	self:addLuaEvent("UPDATE_LEAGUE_REWARDGIFT", self, self.updataRewardGift);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceGrowUpWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.titleTxt1:setLangValue(201243);
	self.titleTip1:setLangValue(201244);
	self.titleTxt4:setLangValue(201245);

	local myContribTimes = DataCenter.allianceUtil:getConstConfig("daily_contri_limit", 1);
	self.titleTip4.text = LanUtil.formateStr(201199, convert_arab_to_chinese(myContribTimes));

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceGrowUpInfo();

	self.headIcon = Lua_AvatarItem.new(self.content);
	local sprite = DataCenter.allianceUtil:getAllianceHeadByIndex(DataCenter.allianceData.myLeagueInfo.head, 2);
	self.headIcon:setLeagueAvatar(sprite, 0.62);
	self.headIcon:setLocation(-217, -300, 0);
	self.headIcon:setRectAnchor(1);

	self.propDragList = Lua_DragList.new(self.content, 400, 119, Lua_AxisDefine.Vertical);
	self.propDragList:setListCell(Lua_AlliancePropItem, 400, 29, 1);
	self.propDragList:setCellSpacing(0, 16);
    self.propDragList:setRectAnchor(1);

    self.taskDragList = Lua_DragList.new(self.content, 630, 180, Lua_AxisDefine.Vertical);
	self.taskDragList:setListCell(Lua_AllianceBuildTaskItem, 620, 55, 1);
    self.taskDragList:setRectAnchor(1);
    self.taskDragList.showTween = false;
    self.taskDragList.tweenId = 2010;

    self.rewardList = Lua_ItemIconList.new(self.content);
    self.rewardList.pivot = 1;
    self.rewardList.canClick = true;
	self.rewardList:setRectAnchor(7);
	self.rewardList:setLocation(-250, 595, 0);
	self.rewardList.scaleVal = 0.8;
	
	self.contributeTypeArr = {};
	local contributeTypeData = DataCenter.allianceUtil.getContributeTypeArr;
	for i = 1, contributeTypeData:getSize() do
		if self.contributeTypeArr[i] == nil then
			self.contributeTypeArr[i] = Lua_AllianceContributeItem.new(self.content);
			self.contributeTypeArr[i]:setLocation(-213 + (i - 1) * 213, 412, 0);
			self.contributeTypeArr[i]:setRectAnchor(7);
		end
		self.contributeTypeArr[i]:setData(contributeTypeData[i]);
	end

	self.receiveRewardBtn:addClickFuntion(self, self.onReceiveRewardBtnClick);
    self.rewardViewTxt:addClickFuntion(self, self.onRewardViewClick);
    self.tipIcon:addClickFuntion(self, self.onTipIconClick);

    self:updateShow();
end

function Lua_AllianceGrowUpWindow:dispose()
	if self.headIcon ~= nil then
		self.headIcon:dispose();
		self.headIcon = nil;
	end
	if self.propDragList ~= nil then
		self.propDragList:dispose();
		self.propDragList = nil;
	end
	if self.taskDragList ~= nil then
		self.taskDragList:dispose();
		self.taskDragList = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.rewardBoxList ~= nil then
		for k, v in pairs(self.rewardBoxList) do
			if v.dispose ~= nil then
				v:dispose();
			end
			v = nil
		end
		self.rewardBoxList = nil;
	end
	if self.rewardRedPoint ~= nil then
		self.rewardRedPoint:dispose();
		self.rewardRedPoint = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceGrowUpWindow:onScreenResize()
	self:superCall("onScreenResize");
	self:updateShow();
end

function Lua_AllianceGrowUpWindow:updateShow()
	local offsetY = self.adaptHeight < 0 and 60 or 0;
	self.winBg:setLocation(0, offsetY, 0);
	self.bg:setLocation(0, -149 + offsetY, 0);
	self.titleBg:setLocation(0, -317 + offsetY, 0);
	self.titleBg1:setLocation(-274, -194 + offsetY, 0);
	self.titleTxt1:setLocation(-273, -195 + offsetY, 0);
	self.titleTip1:setLocation(-55.8, -193 + offsetY, 0);		
	self.titleBg2:setLocation(-273, -438.6 + offsetY, 0);
	self.titleTxt2:setLocation(-273, -439.8 + offsetY, 0);
	self.titleTip2:setLocation(-55.8, -437.4 + offsetY, 0);
	self.headBg:setLocation(-218, -301 + offsetY, 0);
	self.leagueLvBg:setLocation(-218, -381 + offsetY, 0);
	self.contentBg1:setLocation(0, -464 + offsetY, 0);
	self.bg2:setLocation(0, -486 + offsetY, 0);
	self.txt1:setLocation(-165.4, -489 + offsetY, 0);
	self.txt2:setLocation(35.5, -489 + offsetY, 0);
	self.txt3:setLocation(154.2, -489 + offsetY, 0);
	self.txt4:setLocation(250.7, -489 + offsetY, 0);
	self.line1:setLocation(-25, -486 + offsetY, 0);
	self.line2:setLocation(91, -486 + offsetY, 0);
	self.line3:setLocation(191, -486 + offsetY, 0);
	self.tipIcon:setLocation(300, -193 + offsetY, 0);
	self.leagueLvTxt:setLocation(-219, -385 + offsetY, 0);
	self.leagueExpBar:setLocation(98.7, -383.5 + offsetY, 0);

	self.headIcon:setLocation(-217, -300 + offsetY, 0);
	self.propDragList:setLocation(100, -298 + offsetY, 0);
	self.taskDragList:setLocation(0, -600 - self.adaptHeight / 2 + offsetY / 2, 0);

	self.winBg:SetDimensions(720, 1327 + self.adaptHeight + offsetY);
	self.bg:SetDimensions(693, 1172 + self.adaptHeight + offsetY);
	self.contentBg1:SetDimensions(643, 265 + self.adaptHeight + offsetY);
	self.taskDragList:setContentRect(630, 180 + self.adaptHeight + offsetY);
end

function Lua_AllianceGrowUpWindow:updateData()
	local myLeagueInfo = DataCenter.allianceData.myLeagueInfo;
	self.leagueLvTxt.text = LanUtil.formateStr(201102, tostring(myLeagueInfo.level));

	local limit = DataCenter.allianceUtil:getConstConfig("daily_contri_limit", 1);
	self.titleTip4.text = LanUtil.formateStr(201199, limit - DataCenter.allianceData.myContribTime, limit);

	self.buildDayTxt.text = LanUtil.formateStr(201212, DataCenter.allianceData.dailyBuildVal);
	self.buildWeekTxt.text = LanUtil.formateStr(201213, DataCenter.allianceData.weekBuildVal);

	self.leagueExpBar:setMaxValue(myLeagueInfo.curLevelVo.build_val_cond);
	self.leagueExpBar:setValue(myLeagueInfo.buildExp);
	self.leagueExpBar:setText(myLeagueInfo.buildExp .. "/" .. myLeagueInfo.curLevelVo.build_val_cond);

	if self.isFirstIn == nil then
		self.isFirstIn = false;
		self.taskDragList.showTween = true;
	end
	self.propDragList:setArrayData(myLeagueInfo.curLevelVo.getAddPropArr);
	self.taskDragList:setArrayData(DataCenter.allianceUtil.getBuildTaskArr);

	for k, v in pairs(self.contributeTypeArr) do
		v:updateShow();
	end

	self:updateLevelReward();
	self:updataRewardGift();
end

function Lua_AllianceGrowUpWindow:updateLevelReward()
	self.levelRewardInfo = DataCenter.allianceData.getCurLevelReward;
	self.rewardTitleTxt.text = LanUtil.formateStr(201151, self.levelRewardInfo.key);
	self.receiveRewardBtn.label = self.levelRewardInfo.value == 2 and LanUtil.getValue(201153) or LanUtil.getValue(201152);
	if self.levelRewardInfo.value == 1 then
		self.receiveRewardBtn:setStyle(1);
		self.receiveRewardBtn:setMouseEnable(true);
		if self.rewardRedPoint == nil then
			self.rewardRedPoint = Lua_RedPointIcon.new(self.content);
			self.rewardRedPoint:createRedPointEff();
			self.rewardRedPoint:setRectAnchor(7);
			self.rewardRedPoint:setLocation(270, 615, 0);
		end
		self.rewardRedPoint:updateRedPointShow(true);
	else
		self.receiveRewardBtn:setStyle(3);
		self.receiveRewardBtn:setMouseEnable(false);
		if self.rewardRedPoint ~= nil then
			self.rewardRedPoint:updateRedPointShow(false);
		end
	end

	local showReward = DataCenter.allianceUtil:getLevelConfig(self.levelRewardInfo.key, "lvl_reward");
	self.rewardList:setArrayData(showReward);
end

function Lua_AllianceGrowUpWindow:updataRewardGift()
	local rewardArr = DataCenter.allianceUtil.getContributeRewardArr;
	local len = rewardArr:getSize();
	
	self.todayDonateBar:setMaxValue(rewardArr[len].contrib_cond);
	self.todayDonateBar:setValue(DataCenter.allianceData.curContribValue);
	self.todayDonateTxt.text = DataCenter.allianceData.curContribValue;

	for i = 1, len do
		if self.rewardBoxList == nil then
			self.rewardBoxList = {};
		end
		if self.rewardBoxList[i] == nil then
			self.rewardBoxList[i] = Lua_AllianceRewardBoxItem.new(self.content);
			self.rewardBoxList[i]:setRectAnchor(7);
			self.rewardBoxList[i]:setLocation(-200 + rewardArr[i].contrib_cond / rewardArr[len].contrib_cond * 495, 185, 0);
		end
		self.rewardBoxList[i]:setData(rewardArr[i]);
	end
end

function Lua_AllianceGrowUpWindow:onReceiveRewardBtnClick()
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceLevelGift(self.levelRewardInfo.key);
end

function Lua_AllianceGrowUpWindow:onRewardViewClick()
	Lua_WindowUtil.openWin("Lua_AllianceTaskRewardWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_AllianceGrowUpWindow:onTipIconClick()
	local tipsData = { des = LanUtil.getValue(201205), posX = 170, posY = -200 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end




















Lua_AlliancePropItem = class("Lua_AlliancePropItem", Lua_ListCell);

function Lua_AlliancePropItem:ctor(p)
	self:superCall("ctor", p, "AlliancePropItem_skin");
end

function Lua_AlliancePropItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_AlliancePropItem:dispose()
	if self.proTxt ~= nil then
		self.proTxt:dispose();
		self.proTxt = nil;
	end
	self:superCall("dispose");
end

function Lua_AlliancePropItem:setData(data)
	self.icon:setAltas("common_altas_2", data.attr_icon_2);
	self.leftTxt.text = data.show_name .. ":" .. data.showValue;
	if data.nextValue > 0 then
		self.arrow:setEnable(true);
		self.rightTxt:setEnable(true);
		self.rightTxt.text = data.showNextValue;
	else
		self.arrow:setEnable(false);
		self.rightTxt:setEnable(false);
	end
end





















Lua_AllianceBuildTaskItem = class("Lua_AllianceBuildTaskItem", Lua_ListCell);

function Lua_AllianceBuildTaskItem:ctor(p)
	self:superCall("ctor", p, "AllianceBuildTaskItem_skin");
end

function Lua_AllianceBuildTaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.gotoTxt:addClickFuntion(self, self.onGotoClick)
end

function Lua_AllianceBuildTaskItem:dispose()
	self:superCall("dispose");
end

function Lua_AllianceBuildTaskItem:setData(data)
	self.data = data;

	if data.task_type == 1 then
		self.signIcon:setAltas("alliance_atlas_1", "ui_sq_label_11");
		self.titleTxt.text = LanUtil.formateStr(201206, data.task_title)
	else
		self.signIcon:setAltas("alliance_atlas_1", "ui_sq_label_10");
		self.titleTxt.text = LanUtil.formateStr(201207, data.task_title)
	end
	
	local time = 0;
	if DataCenter.allianceData.taskTimeArr[data.id] ~= nil then
		time = DataCenter.allianceData.taskTimeArr[data.id];
	end
	self.timeTxt.text = time .. "/" .. data.num_limit;
	self.buildValueTxt.text = data.get_active_val;

	self.gotoTxt:setEnable(time < data.num_limit);
	self.finishIcon:setEnable(time >= data.num_limit)
end

function Lua_AllianceBuildTaskItem:onGotoClick(go)
	DataCenter.funcPathUtil:gotoFunction(self.data.func_path_id)
	Lua_WindowUtil.openWin("Lua_AllianceGrowUpWindow", Lua_WinParam.ACTION_CLOSE);
end















Lua_AllianceContributeItem = class("Lua_AllianceContributeItem", Lua_DisplayObject);

function Lua_AllianceContributeItem:ctor(p)
	self:superCall("ctor", p, "AllianceContributeItem_skin");
end

function Lua_AllianceContributeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.isEnough = false;

	self.donateBtn:addClickFuntion(self, self.onDonateBtnClick);
end

function Lua_AllianceContributeItem:dispose()
	self:superCall("dispose");
end

function Lua_AllianceContributeItem:setData(data)
	self.data = data;

	self.titleIcon:setAltas(data.show_bg[1], data.show_bg[2]);
	self.contributeTxt.text = data.reward_item;
	self.buildTxt.text = data.prov_build_val;

	local vo = Lua_ToolVo.createToolVo(data.consume_item[1]);
	self.costIcon:setAltas(vo.iconAtlas, vo.iconSprite);

	self.contributeIcon:setAltas(data:getContribIconAltasAndSprite());
	self.buildIcon:setAltas(data:getBuildAltasAndSprite());

	self:updateShow();
end

function Lua_AllianceContributeItem:updateShow()
	local isEnough = DataCenter.moneyData:isMoneyEnough(self.data.consume_item[1], self.data.consume_item[2], false, false, false);
	local str = isEnough and "{1}" or LanUtil.getValue(201300);
	self.costTxt.text = LanUtil.formateStr(str, numberTrans(self.data.consume_item[2]));
	self.costTxt:resetSize();

	if DataCenter.allianceData.isContribLimit then
		self.donateBtn:setStyle(3);
		self.donateBtn:setMouseEnable(false);
		if self.donateRedPoint ~= nil then
			self.donateRedPoint:updateRedPointShow(false);
		end
	else
		self.donateBtn:setStyle(1);
		self.donateBtn:setMouseEnable(true);
		if self.donateRedPoint == nil then
			self.donateRedPoint = Lua_RedPointIcon.new(self.content);
			self.donateRedPoint:createRedPointEff();
			self.donateRedPoint:setLocation(50, -100, 0);
		end
		self.donateRedPoint:updateRedPointShow(isEnough);
	end
end

function Lua_AllianceContributeItem:onDonateBtnClick()
	if DataCenter.moneyData:isMoneyEnough(self.data.consume_item[1], self.data.consume_item[2], true, true, false) then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceContribute(self.data.id);
	end
end























Lua_AllianceRewardBoxItem = class("Lua_AllianceRewardBoxItem", Lua_DisplayObject);

function Lua_AllianceRewardBoxItem:ctor(p)
	self:superCall("ctor", p, "AllianceRewardBoxItem_skin");
end

function Lua_AllianceRewardBoxItem:buildShowItem()
	self:superCall("buildShowItem");

	self.boxIcon:addClickFuntion(self, self.onBoxClick);
end

function Lua_AllianceRewardBoxItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_AllianceRewardBoxItem:setData(data)
	self.data = data;

	self.txt.text = data.contrib_cond;
	self.rewardState = DataCenter.allianceData.contribRewardInfo[data.id];
	if self.rewardState == nil then
		self.boxIcon.alpha = 1;
		self.boxIcon:setAltas("common_altas_4", "ui_djc_box_002_n");
	elseif self.rewardState == 1 then
		self.boxIcon.alpha = 0.01;
		self.boxIcon:setAltas("common_altas_4", "ui_djc_box_002_n");
	elseif self.rewardState == 2 then
		self.boxIcon.alpha = 1;
		self.boxIcon:setAltas("common_altas_4", "ui_djc_box_002_p");
	end

	if self.rewardState == 1 then
		if self.showEff == nil then
			self.showEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ty_xbx_0101_2", "ui_ty_xbx_0101_2", 0, 0);
		end
		self.showEff:setEnable(true);

		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content);
			self.redPointIcon:createRedPointEff();
			self.redPointIcon:setLocation(20, 15, 0);
		end
		self.redPointIcon:updateRedPointShow(true);
	else
		if self.showEff ~= nil then
			self.showEff:setEnable(false);
		end
		if self.redPointIcon ~= nil then
			self.redPointIcon:updateRedPointShow(false);
		end
	end
end

function Lua_AllianceRewardBoxItem:onBoxClick()
	if self.rewardState == 1 then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceContributeGift(self.data.id);
	else
		local param = { itemList = self.data.reward_item, isBottomShow = true, posX = self.posX, posY = self.posY }
		Lua_WindowUtil.openWin("Lua_RewardPreviewWindow", Lua_WinParam.ACTION_OPEN, param);
	end
end