--联盟系统 任务奖励预览Window
Lua_AllianceTaskRewardWindow = class("Lua_AllianceTaskRewardWindow", Lua_Window);

function Lua_AllianceTaskRewardWindow:ctor()
	self:superCall("ctor");

	self.w = 700;
	self.h = 800;
	self.showClose = true;
	self.showWinBg = true;
	self.isClickClose = true;
	self.showBlackMask = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";
	self.windowName = "Lua_AllianceTaskRewardWindow";
	self.skinName = "AllianceTaskRewardWindow_skin";
end

function Lua_AllianceTaskRewardWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_LEAGUE_LEVELREWARD", self, self.updateData);
end

function Lua_AllianceTaskRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);

	self.listBg = UICreate.createUIAtlasImage(self.content, "common_altas_4", "ui_grxx_widget_008", 0, -25, 650, 765);

	self.dragList = Lua_DragList.new(self.content, 624, 750, Lua_AxisDefine.Vertical);
	self.dragList:setLocation(0, -25, 0);
	self.dragList:setListCell(Lua_AllianceTaskViewItem, 624, 158, 1);
	self.dragList:setCellSpacing(0, 10);

    self:updateData();
end

function Lua_AllianceTaskRewardWindow:updateData()
	local levelRewardInfo = DataCenter.allianceData.getCurLevelReward;
	self.dragList:setArrayData(DataCenter.allianceUtil.getAllianceLevelArr);
	self.dragList:moveToIndex(levelRewardInfo.key, true, false);
end

function Lua_AllianceTaskRewardWindow:dispose()
	self:superCall("dispose");
end


















Lua_AllianceTaskViewItem = class("Lua_AllianceTaskViewItem", Lua_ListCell);

function Lua_AllianceTaskViewItem:ctor(p)
	self:superCall("ctor", p, "AllianceTaskViewItem_skin");
end

function Lua_AllianceTaskViewItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_ItemIconList.new(self.content);
	self.rewardList:setLocation(-245, -16.5, 0);
	self.rewardList.pivot = 1;

	self.receiveBtn:addClickFuntion(self, self.onReceiveBtnClick);
end

function Lua_AllianceTaskViewItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceTaskViewItem:setData(data)
	self.data = data;

	self.titleTxt.text = LanUtil.formateStr(201151, data.id);
	self.rewardList:setArrayData(data.lvl_reward);

	self.rewardState = DataCenter.allianceData:levelRewardState(data.id);
	if self.rewardState == 0 then
		self.tipTxt:setEnable(true);
		self.receiveBtn:setEnable(false);
		self.tipIcon:setEnable(false);
	elseif self.rewardState == 1 then
		self.tipTxt:setEnable(false);
		self.receiveBtn:setEnable(true);
		self.tipIcon:setEnable(false);
	elseif self.rewardState == 2 then
		self.tipTxt:setEnable(false);
		self.receiveBtn:setEnable(false);
		self.tipIcon:setEnable(true);
	end
end

function Lua_AllianceTaskViewItem:onPressClick()
	self.rewardList:onBoundClick();
end

function Lua_AllianceTaskViewItem:onReceiveBtnClick()
	if self.rewardState == 1 then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceLevelGift(self.data.id);
	end
end