--联盟系统 审核申请Window
Lua_AllianceApplyWindow = class("Lua_AllianceApplyWindow", Lua_Window);

function Lua_AllianceApplyWindow:ctor()
	self:superCall("ctor");

	self.w = 700;
	self.h = 850;
	self.showClose = true;
	self.showWinBg = true;
	self.isClickClose = true;
	self.showBlackMask = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";

	self.windowName = "Lua_AllianceApplyWindow";
	self.skinName = "AllianceApplyWindow_skin";
end

function Lua_AllianceApplyWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	
	self:addLuaEvent("UPDATE_LEAGUE_APPLYLIST", self, self.updateData);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceApplyWindow:buildShowItem()
	self:superCall("buildShowItem");

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sGetApplyList();

	self.dragList = Lua_DragList.new(self.content, 631, 640, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_AllianceApplyItem, 631, 130, 1);
    self.dragList:setLocation(0, 30, 0);

	self.oneKeyCancelBtn:addClickFuntion(self, self.onOneKeyCancelClick);
	self.oneKeyAcceptBtn:addClickFuntion(self, self.onOneKeyAcceptClick);
end

function Lua_AllianceApplyWindow:dispose()
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sGetMemberList();
	
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceApplyWindow:updateData(arr)
	self.applyNum = arr:getSize();
	self.dragList:setArrayData(arr);
end

function Lua_AllianceApplyWindow:onOneKeyCancelClick()
	if self.applyNum > 0 then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sCheckApply(4);
	end
end

function Lua_AllianceApplyWindow:onOneKeyAcceptClick()
	if self.applyNum > 0 then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sCheckApply(3);
	end
end



























Lua_AllianceApplyItem = class("Lua_AllianceApplyItem", Lua_ListCell);

function Lua_AllianceApplyItem:ctor(p)
	self:superCall("ctor", p, "AllianceApplyItem_skin");
end

function Lua_AllianceApplyItem:buildShowItem()
	self:superCall("buildShowItem");

	self.playerAvatarItem = Lua_AvatarItem.new(self.content);
	self.playerAvatarItem:setScale(0.7, 0.7)
	self.playerAvatarItem:setLocation(-230, 0, 0);

	self.acceptBtn:addClickFuntion(self, self.onAcceptBtnClick);
	self.cancelBtn:addClickFuntion(self, self.onCancelBtnClick);
end

function Lua_AllianceApplyItem:dispose()
	if self.playerAvatarItem ~= nil then
		self.playerAvatarItem:dispose();
		self.playerAvatarItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceApplyItem:setData(data)
	self.data = data;

	self.playerAvatarItem:setRoleId(data.roleId, data.serverFlag)
	self.playerAvatarItem:setRoleDressUp(data.dress_info)
	
	self.playerNameTxt.text = data.name;
	self.playerFightTxt.text = data.force;

	if data.online == 1 then
		self.playerOnlineTxt:setLangValue(201118);
	else
		local hour = Mathf.Modf(data.offlineTime / 3600);
		if hour < 1 then
			if data.offlineTime < 60 then
				self.playerOnlineTxt.text = LanUtil.formateStr(201119, "1");
			else
				self.playerOnlineTxt.text = LanUtil.formateStr(201119, Mathf.Modf(data.offlineTime / 60));
			end
		elseif hour < 48 then
			self.playerOnlineTxt.text = LanUtil.formateStr(201120, hour);
		elseif hour < 168 then
			self.playerOnlineTxt.text = LanUtil.formateStr(201121, "2");
		else
			self.playerOnlineTxt.text = LanUtil.formateStr(201121, "7");
		end
	end
end

function Lua_AllianceApplyItem:onAcceptBtnClick()
	if self.data == nil then return end;

	if DataCenter.allianceData.myLeagueInfo.isMaxMember then
		OperateAlert.showLangValue(201139);
		return;
	end
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sCheckApply(1, self.data.roleId);
end

function Lua_AllianceApplyItem:onCancelBtnClick()
	if self.data == nil then return end;
	
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sCheckApply(2, self.data.roleId);
end