--联盟系统 解散联盟Window
Lua_AllianceDisbandWindow = class("Lua_AllianceDisbandWindow", Lua_Window);

function Lua_AllianceDisbandWindow:ctor()
	self:superCall("ctor");

	self.w = 650;
	self.h = 500;
	self.showClose = true;
	self.showWinBg = true;
	self.isClickClose = true;
	self.showBlackMask = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";

	self.windowName = "Lua_AllianceDisbandWindow";
	self.skinName = "AllianceDisbandWindow_skin";
end

function Lua_AllianceDisbandWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("START_DISMISS_LEAGUE", self, self.updateData);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceDisbandWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:updateData();

	self.cancelBtn:addClickFuntion(self, self.onCancelBtnClick);
	self.disbandBtn:addClickFuntion(self, self.onDisbandBtnClick);
end

function Lua_AllianceDisbandWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.updataSureBtnTime);
	Lua_CommonUtil.removeTimer(self, self.onCountDown);
	self:superCall("dispose");
end

function Lua_AllianceDisbandWindow:updateData()
	if DataCenter.allianceData.myLeagueInfo.startDiscussTick == 0 then
		Lua_CommonUtil.removeTimer(self, self.onCountDown);
		self.isOnTimer = false;

		self.startTime = DataCenter.allianceUtil:getConstConfig("league_sure_click_time", 5)[1];
		Lua_CommonUtil.addTimer("updataSureBtnTime", 1, self, self.updataSureBtnTime);

		self.contentTxt:setLangValue(201133);
		self.timeTxt.text = "";
		self.cancelBtn:setLangValue(100001);
		self.disbandBtn.label = LanUtil.formateStr(107499, tostring(self.startTime));
		self.disbandBtn:setBtnEnable(false);
	else
		self.contentTxt:setLangValue(201134);
		self.cancelBtn:setLangValue(201174);

		self:setCountDown();
	end
end

function Lua_AllianceDisbandWindow:updataSureBtnTime()
	self.startTime = self.startTime - 1;
	if self.startTime <= 0 then
		Lua_CommonUtil.removeTimer(self, self.updataSureBtnTime);

		self.disbandBtn:setLangValue(100002);
		self.disbandBtn:setBtnEnable(true);
	else
		self.disbandBtn.label = LanUtil.formateStr(107499, tostring(self.startTime));
		self.disbandBtn:setBtnEnable(false);
	end
end

function Lua_AllianceDisbandWindow:setCountDown()
	self.timer = DataCenter.allianceData.myLeagueInfo.getDiscussRemainTime;
	if self.timer > 0 then
		if not self.isOnTimer then
			self.isOnTimer = true;
			Lua_CommonUtil.addTimer("onCountDown", 1, self, self.onCountDown);

			self.disbandBtn:setBtnEnable(false);
			self.timeTxt.text = Lua_TimeTransform.transSeconds6(self.timer, true, true);
		end
	else
		self.timeTxt.text = "";
	end
end

function Lua_AllianceDisbandWindow:onCountDown()
	self.timer = self.timer - 1;
	if self.timer > 0 then
		self.timeTxt.text = Lua_TimeTransform.transSeconds6(self.timer, true, true);
	else
		if self.isOnTimer then
			self.isOnTimer = false;
			Lua_CommonUtil.removeTimer(self, self.onCountDown);

			self.disbandBtn:setBtnEnable(true);
			self.timeTxt.text = "";
		end
	end
end

function Lua_AllianceDisbandWindow:onCancelBtnClick()
	if DataCenter.allianceData.myLeagueInfo.startDiscussTick ~= 0 then
		local tipsData = {
			des = LanUtil.getValue(201135),
			btnType = 1,
			owner = self,
			sureFun = self.onSureCancelBtnClick
		};
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	else
		self:hide();
	end
end

function Lua_AllianceDisbandWindow:onSureCancelBtnClick()
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sDisbandAlliance(2);
end

function Lua_AllianceDisbandWindow:onDisbandBtnClick()
	if DataCenter.allianceData.myLeagueInfo.startDiscussTick == 0 then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sDisbandAlliance(1);
	else
		if DataCenter.allianceData.myLeagueInfo.getDiscussRemainTime <= 0 then
			local tipsData = {
				des = LanUtil.getValue(201136),
				btnType = 1,
				owner = self,
				sureFun = self.onSureDisbandBtnClick
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
		end
	end
end

function Lua_AllianceDisbandWindow:onSureDisbandBtnClick()
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sDisbandAlliance(3);
end