--联盟系统 更换联盟头像Window
Lua_AllianceHeadIconWindow = class("Lua_AllianceHeadIconWindow", Lua_Window);

function Lua_AllianceHeadIconWindow:ctor()
	self:superCall("ctor");

	self.isClickClose = true;
	self.showBlackMask = true;
	
	self.windowName = "Lua_AllianceHeadIconWindow";
	self.skinName = "AllianceHeadIconWindow_skin";
end

function Lua_AllianceHeadIconWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	
	self:addLuaEvent("SELECT_LEAGUE_HEADICON", self, self.updateSelect);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceHeadIconWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.headItemArr = Array();
	local num = DataCenter.allianceUtil:getConstConfig("league_headIcon_num", 1);
	local item;
	local row;
	local column;
	for i = 1, num do
		row = (i - 1) % 5;
		column = Mathf.Ceil(i / 5) - 1;

		item = Lua_AllianceHeadIconItem.new(self.content, i);
		item:setLocation(-260 + row * 130, 85 - column * 100, 0);
		self.headItemArr:add(item);
	end

	self.headIconItem = Lua_AvatarItem.new(self.content);
	self.headIconItem:setLocation(0, 256, 0);

	self:updateSelect(DataCenter.allianceData.myLeagueInfo.head);

	self.changeBtn:addClickFuntion(self, self.onChangeClick);
end

function Lua_AllianceHeadIconWindow:dispose()
	if self.headItemArr ~= nil then
		self.headItemArr:dispose();
		self.headItemArr = nil;
	end
	if self.headIconItem ~= nil then
		self.headIconItem:dispose();
		self.headIconItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceHeadIconWindow:updateSelect(index)
	if self.curIndex == index then return end
	self.curIndex = index;
	for i = 1, self.headItemArr:getSize() do
		self.headItemArr[i]:setSelect(i == index)
	end
	local sprite = DataCenter.allianceUtil:getAllianceHeadByIndex(index, 2);
	self.headIconItem:setLeagueAvatar(sprite, 0.62);
end

function Lua_AllianceHeadIconWindow:onChangeClick()
	if self.curIndex ~= nil then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sReviseAllianceIocn(self.curIndex);
		self:hide();
	end
end




















Lua_AllianceHeadIconItem = class("Lua_AllianceHeadIconItem", Lua_DisplayObject);

function Lua_AllianceHeadIconItem:ctor(p, index)
	self.index = index;
	self:superCall("ctor", p, "AllianceHeadIconItem_skin");
end

function Lua_AllianceHeadIconItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setSiblingIndex(1)
	local sprite = DataCenter.allianceUtil:getAllianceHeadByIndex(self.index,1);
	self.avatarItem:setLeagueAvatar(sprite);
	self.avatarItem:setAvatarClick(self, self.onHeadImageClick);

	self.useIcon:setEnable(self.index == DataCenter.allianceData.myLeagueInfo.head);
end

function Lua_AllianceHeadIconItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceHeadIconItem:onHeadImageClick()
	Lua_MsgUtil.callFunc("SELECT_LEAGUE_HEADICON", self.index);
end

function Lua_AllianceHeadIconItem:setSelect(val)
	self.selectBg:setEnable(val);
end