--联盟系统 联盟设置Window
checkRequire("Lua_AllianceLimitItem");
Lua_AllianceLimitWindow = class("Lua_AllianceLimitWindow", Lua_Window);

function Lua_AllianceLimitWindow:ctor()
	self:superCall("ctor");
	
	self.w = 600;
	self.h = 800;
	self.showClose = true;
	self.showWinBg = true;
	self.isClickClose = true;
	self.showBlackMask = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";

	self.windowName = "Lua_AllianceLimitWindow";
	self.skinName = "AllianceLimitWindow_skin";
end

function Lua_AllianceLimitWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);

	self.noticeLabel:setLangValue(201242);
	self.limitItemArr = Array();
	local myLeagueInfo = DataCenter.allianceData.myLeagueInfo;
	local applyLimitInfo = DataCenter.allianceUtil:getConstConfig("apply_limit", 5);
	local item;
	for i = 1, #applyLimitInfo do
		if i == 1 then
			item = Lua_AllianceLimitItem.new(self.content, 1, applyLimitInfo[i], myLeagueInfo.levelCond);
		else
			item = Lua_AllianceLimitItem.new(self.content, 1, applyLimitInfo[i], myLeagueInfo.forceCond);
		end
		item:setLocation(-5, 203 - (i - 1) * 65, 0);
		self.limitItemArr:add(item);
	end

	applyLimitInfo = DataCenter.allianceUtil:getConstConfig("verify_option", 5);
	item = Lua_AllianceLimitItem.new(self.content, 2, applyLimitInfo, myLeagueInfo.autoJoin + 1);
	item:setLocation(-5, 73, 0);
	self.limitItemArr:add(item);

	self.noticeInput.text = myLeagueInfo.declaration;
	self.noticeInput.characterLimit = DataCenter.allianceUtil:getConstConfig("max_notice_len", 1);
	self.noticeInput.colorStr = Lua_ColorDefine.transColorStr("846651");
	self.noticeInput:onChange(self, self.onChangeShow);

	self.sureBtn:addClickFuntion(self, self.onSureBtnClick);

	self:onChangeShow();
end

function Lua_AllianceLimitWindow:dispose()
	if self.limitItemArr ~= nil then
		self.limitItemArr:dispose();
		self.limitItemArr = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceLimitWindow:onChangeShow()
	local infactLen = utf8len(self.noticeInput.text);
	local totalLen = self.noticeInput.characterLimit / 2;
	if infactLen > totalLen then
		infactLen = totalLen;
		self.noticeInput.text = string.sub(self.noticeInput.text, 1, totalLen);
	end
	self.numTxt.text = infactLen .. "/" .. totalLen;
end

function Lua_AllianceLimitWindow:onSureBtnClick()
	local noticeStr = self.noticeInput.text;
	if noticeStr == "" then
		noticeStr = nil;
	end

	if Lua_CommonUtil.checkIsInvalid(noticeStr) then
		return;
	end

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sSetAllianceInfo(self.limitItemArr[3].getRealValue, self.limitItemArr[2].getRealValue, 
		self.limitItemArr[1].getRealValue, noticeStr);
	self:hide();
end