--联盟系统 联盟日志Window
checkRequire("Lua_AllianceLogItem");
Lua_AllianceLogWindow = class("Lua_AllianceLogWindow", Lua_Window);

function Lua_AllianceLogWindow:ctor()
	self:superCall("ctor");

	self.w = 700;
	self.h = 800;
	self.showClose = true;
	self.showWinBg = true;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";

	self.windowName = "Lua_AllianceLogWindow";
	self.skinName = "AllianceLogWindow_skin";
end

function Lua_AllianceLogWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	
	self:addLuaEvent("UPDATE_LEAGUE_LOGLIST", self, self.updateData);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceLogWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.leagueMessageCheck:setLangValue(201241)
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sGetLogList();

	self.dragContainer = Lua_DragContainer.new(self.content, 634, 690, Lua_AxisDefine.Vertical);
	self.dragContainer:setLocation(0, 0.5, 0);

    self.curType = 0;
    self.checkBoxList = {self.memberChangeCheck, self.donationStateCheck, self.leagueMessageCheck};

    self.memberChangeCheck:addBoxChange(self, self.onMemberChangeChange);
	self.donationStateCheck:addBoxChange(self, self.onDonationStateChange);
	self.leagueMessageCheck:addBoxChange(self, self.onLeagueMessageChange);
end

function Lua_AllianceLogWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	if self.checkBoxList ~= nil then
		for k, v in pairs(self.checkBoxList) do
			if v.dispose ~= nil then
				v:dispose();
			end
			v = nil;
		end
		self.checkBoxList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceLogWindow:updateData(data)
	self.data = data;
	self:updateLogShow();
end

function Lua_AllianceLogWindow:updateLogShow()
	if self.data == nil then return end

	local arr = self.data[self.curType];
	local dateArr = Array();
	local logList = {};
	if arr ~= nil then
		arr:sort("log_tick", true);

		local date;
		for i = 1, arr:getSize() do
			date = tostring(os.date("%Y%m%d", arr[i].log_tick));
			if logList[date] == nil then
				logList[date] = Array();
				dateArr:add(date);
			end
			logList[date]:add(arr[i]);
		end
	end

	self.dragContainer:clearList();
	local len = dateArr:getSize();
	for i = 1, len do
		self.dragContainer:addSubContainer(Lua_AllianceLogItem, logList[dateArr[i]], false);
	end
	self.dragContainer:updateChildPos();
	self.dragContainer:moveToIndex(1, true);
end

function Lua_AllianceLogWindow:updateSelect(index, state)
	if state == false then
		self.curType = 0;
		self.memberChangeCheck.selected = false;
		self.donationStateCheck.selected = false;
		self.leagueMessageCheck.selected = false;
	else
		self.curType = index;
		for i = 1, #self.checkBoxList do
			self.checkBoxList[i].selected = index == i;
		end
	end
	self:updateLogShow();
end

function Lua_AllianceLogWindow:onMemberChangeChange(val)
	self:updateSelect(1, val);
end

function Lua_AllianceLogWindow:onDonationStateChange(val)
	self:updateSelect(2, val);
end

function Lua_AllianceLogWindow:onLeagueMessageChange(val)
	self:updateSelect(3, val);
end