--联盟系统 群发邮件Window
Lua_AllianceMailWindow = class("Lua_AllianceMailWindow", Lua_Window);

function Lua_AllianceMailWindow:ctor()
	self:superCall("ctor");

	self.w = 650;
	self.h = 500;
	self.showClose = true;
	self.showWinBg = true;
	self.isClickClose = true;
	self.showBlackMask = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";

	self.windowName = "Lua_AllianceMailWindow";
	self.skinName = "AllianceMailWindow_skin";
end

function Lua_AllianceMailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);

	self.maxTime = DataCenter.allianceUtil:getConstConfig("every_day_mass_mail_num", 1);

	self.contentInput.characterLimit = DataCenter.allianceUtil:getConstConfig("mass_mail_max_len", 1);
	self.contentInput:onChange(self, self.onChangeShow);

	self.sendBtn:addClickFuntion(self, self.onSendBtnClick);

	self:updateData();
	self:onChangeShow();
end

function Lua_AllianceMailWindow:dispose()
	self:superCall("dispose");
end

function Lua_AllianceMailWindow:updateData()
	self.limitTime = DataCenter.allianceData.myLeagueInfo.leftMailNum;
	self.limitTxt.text = LanUtil.formateStr(201132, self.limitTime, self.maxTime);
end

function Lua_AllianceMailWindow:onChangeShow()
	local infactLen = utf8len(self.contentInput.text);
	local totalLen = self.contentInput.characterLimit / 2;
	if infactLen > totalLen then
		infactLen = totalLen;
		self.contentInput.text = string.sub(self.contentInput.text, 1, totalLen);
	end
	self.numTxt.text = infactLen .. "/" .. totalLen;
end

function Lua_AllianceMailWindow:onSendBtnClick()
	if self.limitTime <= 0 then
		OperateAlert.showLangValue(201209);
		return;
	end

	local str = self.contentInput.text;
	if str == nil or str == "" then
		OperateAlert.showLangValue(201140);
		return;
	end

	if Lua_CommonUtil.checkIsInvalid(str) then
		return;
	end

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sSendMassMail(str);
	self:hide();
end