--联盟系统 联盟成员Window
checkRequire("Lua_AllianceMenuListVo");
Lua_AllianceMemberWindow = class("Lua_AllianceMemberWindow", Lua_Window);

function Lua_AllianceMemberWindow:ctor()
	self:superCall("ctor");

	self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.showBlackMask = true;
	self.layer = MainWinDefine.MAIN_MENU_TOP_LAYER;

	self.windowName = "Lua_AllianceMemberWindow";
	self.skinName = "AllianceMemberWindow_skin";
end

function Lua_AllianceMemberWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_LEAGUE_POSITION", self, self.getMemberList);
	self:addLuaEvent("UPDATE_LEAGUEMEMEBER_INFO", self, self.updateData);
	self:addLuaEvent("UPDATE_LEAGUE_INFO", self, self.updateLeagueData);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceMemberWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.nameTxt1:setLangValue(201248);
	self.nameTxt5:setLangValue(201240);

	self.dragList = Lua_DragList.new(self.content, 690, 840 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_AllianceMemberItem, 690, 130, 1);
    self.dragList:setLocation(0, -180, 0);
    self.dragList.tweenId = 2010;

	self.leagueAvatarItem = Lua_AvatarItem.new(self.content);
	self.leagueAvatarItem:setRectAnchor(1);
	self.leagueAvatarItem:setLocation(-194, -233, 0);
	self.leagueAvatarItem:setSiblingIndex(1);
	self.leagueAvatarItem:setAvatarClick(self, self.onChangeIconClick)

	self.optionBtn:addClickFuntion(self, self.onOptionBtnClick);
	self.logBtn:addClickFuntion(self, self.onLogBtnClick);
	self.manageBtn:addClickFuntion(self, self.onManageBtnClick);

	self:getMemberList();
end

function Lua_AllianceMemberWindow:dispose()
	if DataCenter.roleData.league_id ~= 0 then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sGetAllianceInfo();--更新联盟信息
	end
	
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.leagueAvatarItem ~= nil then
		self.leagueAvatarItem:dispose();
		self.leagueAvatarItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceMemberWindow:onScreenResize()
	self:superCall("onScreenResize");
	self.dragList:setContentRect(690, 840 + self.adaptHeight);
end

function Lua_AllianceMemberWindow:getMemberList()
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sGetMemberList();
end

function Lua_AllianceMemberWindow:updateData()
	self:updateLeagueData();
	self.dragList:setArrayData(DataCenter.allianceData.memberArr);
end

function Lua_AllianceMemberWindow:updateLeagueData()
	local data = DataCenter.allianceData.myLeagueInfo;
	local sprite = DataCenter.allianceUtil:getAllianceHeadByIndex(data.head, 2);
	self.leagueAvatarItem:setLeagueAvatar(sprite);
	self.leagueNameTxt.text = data.showLeagueName;
	self.leagueNumberTxt.text = data.id;
	self.memberNumTxt.text = data.memberAmount .. "/" .. data.maxMember;
	self.leagueFightTxt.text = data.force;
	self.leagueLvTxt.text = data.level;
	self.leagueNotice.text = data.declaration;

	self.expBar:setMaxValue(data.curLevelVo.build_val_cond);
	self.expBar:setValue(data.buildExp);
	self.expBar:setText(data.buildExp .. "/" .. data.curLevelVo.build_val_cond);
end

function Lua_AllianceMemberWindow:onChangeIconClick()
	if DataCenter.allianceData:getCurDutyPower(Lua_AllianceData.OPERATION_TYPE.MODIF_HEAD) then
		Lua_WindowUtil.openWin("Lua_AllianceHeadIconWindow", Lua_WinParam.ACTION_OPEN);
	else
		OperateAlert.showLangValue(201301);
	end
end

function Lua_AllianceMemberWindow:onOptionBtnClick()
	if DataCenter.allianceData:getCurDutyPower(Lua_AllianceData.OPERATION_TYPE.SET_LEAGUE_INFO) then
		Lua_WindowUtil.openWin("Lua_AllianceLimitWindow", Lua_WinParam.ACTION_OPEN);
	else
		OperateAlert.showLangValue(201198);
	end
end

function Lua_AllianceMemberWindow:onLogBtnClick()
	Lua_WindowUtil.openWin("Lua_AllianceLogWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_AllianceMemberWindow:onManageBtnClick()
	local menuData = {};
	menuData.posX = 180;
	menuData.posY = 290 + self.adaptHeight / 2;
	menuData.menuArr = Array();

	if DataCenter.allianceData:getCurDutyPower(Lua_AllianceData.OPERATION_TYPE.APPLY_HANDEL) then--申请处理
		menuData.menuArr:add(Lua_AllianceMenuListVo.new(Lua_AllianceMenuListVo.APPLY_INFO));
	end
	if DataCenter.allianceData:getCurDutyPower(Lua_AllianceData.OPERATION_TYPE.MASS_LEAGUE_MAIL) then--群发邮件
		menuData.menuArr:add(Lua_AllianceMenuListVo.new(Lua_AllianceMenuListVo.MASS_MAIL));
	end
	if DataCenter.allianceData:getCurDutyPower(Lua_AllianceData.OPERATION_TYPE.EXIT_LEAGUE) then--自愿退出联盟
		menuData.menuArr:add(Lua_AllianceMenuListVo.new(Lua_AllianceMenuListVo.EXIT_LEAGUE));
	end
	if DataCenter.allianceData:getCurDutyPower(Lua_AllianceData.OPERATION_TYPE.DISMISS) then--解散联盟
		menuData.menuArr:add(Lua_AllianceMenuListVo.new(Lua_AllianceMenuListVo.DISMISS));
	end
	Lua_WindowUtil.openWin("Lua_AllianceMenuListWindow", Lua_WinParam.ACTION_OPEN, menuData);
end






















Lua_AllianceMemberItem = class("Lua_AllianceMemberItem", Lua_ListCell);

function Lua_AllianceMemberItem:ctor(p)
	self:superCall("ctor", p, "AllianceMemberItem_skin");
end

function Lua_AllianceMemberItem:buildShowItem()
	self:superCall("buildShowItem");
	self.btnImpeach:setEnable(false);
	self.btnImpeach:addClickFuntion(self, self.onBtnImpeachClick);

	self.playerAvatarItem = Lua_AvatarItem.new(self.content);
	self.playerAvatarItem:setScale(0.7, 0.7);
	self.playerAvatarItem:setLocation(-285, 2, 0);
end

function Lua_AllianceMemberItem:dispose()
	if self.playerAvatarItem ~= nil then
		self.playerAvatarItem:dispose();
		self.playerAvatarItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceMemberItem:setData(data)
	self.data = data;

	self.playerAvatarItem:setRoleId(data.roleId, data.serverFlag);
	self.playerAvatarItem:setRoleDressUp(data.dress_info)

	self.playerNameTxt.text = data.showName;
	self.playerFightTxt.text = ":" .. data.force;
	self.playerContributeTxt.text = data.contribute;

	self.playerDutyTxt.text = DataCenter.allianceUtil:getLeagueIdentityByPosition(data.position);

	if data.online == 1 then
		self.playerOnlineTxt:setLangValue(201118);
		self.playerOnlineTxt.colorStr = Lua_ColorDefine.transColorStr("25aa1b");
	else
		local hour = Mathf.Modf(data.offlineTime / 3600);
		if hour < 1 then
			if data.offlineTime < 60 then
				self.playerOnlineTxt.text = LanUtil.formateStr(201119, "1");
			else
				self.playerOnlineTxt.text = LanUtil.formateStr(201119, Mathf.Modf(data.offlineTime / 60));
			end
		elseif hour < 48 then
			self.playerOnlineTxt.text = LanUtil.formateStr(201120, hour);
		elseif hour < 168 then
			self.playerOnlineTxt.text = LanUtil.formateStr(201121, "2");
		else
			self.playerOnlineTxt.text = LanUtil.formateStr(201121, "7");
		end
		self.playerOnlineTxt.colorStr = Lua_ColorDefine.transColorStr("5d452e");
	end

	if data.online ~= 1 and data.position == 1 then
		local limit = DataCenter.allianceUtil:getConstConfig("impeach_league_leader", 1);
		if data.offlineTime > limit then
			self.btnImpeach:setEnable(true);
			self.contributeBg:setEnable(false);
			self.playerContributeTxt:setEnable(false);
		else
			self.btnImpeach:setEnable(false);
			self.contributeBg:setEnable(true);
			self.playerContributeTxt:setEnable(true);
		end
	else
		self.btnImpeach:setEnable(false);
		self.contributeBg:setEnable(true);
		self.playerContributeTxt:setEnable(true);
	end
end

function Lua_AllianceMemberItem:onPressClick()
	local curMemberId = self.data.roleId;
	if self.data == nil or tonumber(curMemberId) == tonumber(DataCenter.roleData.roleId) then return end
	
	local menuData = {};
	menuData.menuArr = Array();

	menuData.menuArr:add(Lua_AllianceMenuListVo.new(Lua_AllianceMenuListVo.MEMBER_INFO, self.data));--玩家信息 

	local appiontArr = Array();
	if DataCenter.allianceData:getCurDutyPower(Lua_AllianceData.OPERATION_TYPE.AUTH_VICE_COMMANDER) then
		appiontArr:add(Lua_AllianceMenuListVo.new(Lua_AllianceMenuListVo.VICE_LEADER_DUTY, curMemberId));--副盟主职位 
	end
	if DataCenter.allianceData:getCurDutyPower(Lua_AllianceData.OPERATION_TYPE.AUTH_ELITE_POSITION) then
		appiontArr:add(Lua_AllianceMenuListVo.new(Lua_AllianceMenuListVo.ELITE_DUTY, curMemberId));--精英职位
	end
	if DataCenter.allianceData:getCurDutyPower(Lua_AllianceData.OPERATION_TYPE.AUTH_GENERAL_MEMBER) then
		appiontArr:add(Lua_AllianceMenuListVo.new(Lua_AllianceMenuListVo.GENERAL_DUTY, curMemberId));--成员职位
	end
	if appiontArr:getSize() > 0 then
		menuData.menuArr:add(Lua_AllianceMenuListVo.new(Lua_AllianceMenuListVo.APPOINT_DUTY, nil, appiontArr));--任命
	end

	if DataCenter.allianceData:getCurDutyPower(Lua_AllianceData.OPERATION_TYPE.HADN_OVER) then
		menuData.menuArr:add(Lua_AllianceMenuListVo.new(Lua_AllianceMenuListVo.TRANSFER_LEADER, self.data));--转让盟主
	end

	if DataCenter.allianceData:getCurDutyPower(Lua_AllianceData.OPERATION_TYPE.EXPEL_ALLIANCE) then
		menuData.menuArr:add(Lua_AllianceMenuListVo.new(Lua_AllianceMenuListVo.EXPEL_MEMBER, self.data));--逐出成员
	end
	Lua_WindowUtil.openWin("Lua_AllianceMenuListWindow", Lua_WinParam.ACTION_OPEN, menuData);
end

function Lua_AllianceMemberItem:onBtnImpeachClick(go)
	local cost = DataCenter.allianceUtil:getConstConfig("impeach_league_leader", 5);
	local str = spliceIconStrById(cost[1][1]);
	local tipsData = { des = LanUtil.getValue(201224), btnType = 1,  owner = self, sureFun = self.onImpeach, 
						sureLabel = LanUtil.formateStr(201223, str, tostring(cost[1][2]))};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_AllianceMemberItem:onImpeach(go)
	local cost = DataCenter.allianceUtil:getConstConfig("impeach_league_leader", 5);
	local costId = DataCenter.packData:checkConsumeEnough(cost);
	if costId == nil then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sImpeachDirector();
	else
		DataCenter.packUtil:openPathWindow(costId);
	end	
end