--联盟系统 联盟排名Window
Lua_AllianceRankWindow = class("Lua_AllianceRankWindow", Lua_Window);

function Lua_AllianceRankWindow:ctor()
	self:superCall("ctor");

	self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.showBlackMask = true;
	self.layer = MainWinDefine.MAIN_MENU_TOP_LAYER;

	self.windowName = "Lua_AllianceRankWindow";
	self.skinName = "AllianceRankWindow_skin";
end

function Lua_AllianceRankWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_LEAGUE_RANK", self, self.updateData);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceRankWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.txt2:setLangValue(201246);
	self.bg:SetDimensions(720, 936 + self.adaptHeight);

	self.dragList = Lua_DragList.new(self.content, 700, 900 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_AllianceRankItem, 700, 140, 1);
    self.dragList:setLocation(0, -140, 0);
    self.dragList.callBackOwner = self;
    self.dragList.turnPageCallBack = self.addPage;
    self.dragList.tweenId = 2010;

    Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceRank(0);
end

function Lua_AllianceRankWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceRankWindow:onScreenResize()
	self:superCall("onScreenResize");

	self.bg:SetDimensions(720, 936 + self.adaptHeight);
	self.dragList:setContentRect(700, 900 + self.adaptHeight);
end

function Lua_AllianceRankWindow:updateData(msg)
	if msg.num == 1 then
		self.rankArr = Array();
	end
	for k, v in ipairs(msg.league_list) do
		self.rankArr:add(v);
	end

	self.dragList:setArrayData(self.rankArr);
	self.dragList.isPageEnd = msg.is_last_num == 1; -- 是否是最后一页 1：是最后一页 0：不是
end

function Lua_AllianceRankWindow:addPage()
	if DataCenter.allianceData.isPageEnd then return end
	
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceRank(1);
end


















Lua_AllianceRankItem = class("Lua_AllianceRankItem", Lua_ListCell);

function Lua_AllianceRankItem:ctor(p)
	self:superCall("ctor", p, "AllianceRankItem_skin");
end

function Lua_AllianceRankItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setLocation(-177, 0, 0);
end

function Lua_AllianceRankItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	if self.rankNum ~= nil then
		self.rankNum:dispose();
		self.rankNum = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceRankItem:setData(data)
	self.data = data;

	local sprite = DataCenter.allianceUtil:getAllianceHeadByIndex(data.league_head, 1);
	self.avatarItem:setLeagueAvatar(sprite, 0.9);
	self.avatarItem:setLeagueLevel(LanUtil.formateStr(201214, tostring(data.league_level)));

	self.nameTxt.text = data.league_name;
	-- self.levelTxt.text = LanUtil.formateStr(201147, data.league_level, data.league_num, data.league_num_limit);
	self.forceTxt.text = data.league_total_force;
	self.memberTxt.text = LanUtil.formateStr("({1}/{2})",data.league_num, data.league_num_limit);

	local bloodRatio = data.boss_left_blood / data.boss_total_blood;
	if bloodRatio > 0 and bloodRatio <= 0.01 then
		bloodRatio = string.format("%.3f", 0.001) * 100;
	else
		bloodRatio = string.format("%.2f", bloodRatio) * 100;
	end
	self.infoTxt.text = LanUtil.formateStr(201197, data.league_stage_id, bloodRatio);

	if data.rank <= 3 then
		self.topSp:setAltas("common_altas_3", "ui_djc_window_00" .. data.rank);
		if self.rankNum ~= nil then
			self.rankNum:setEnable(false);
		end
	else
		self.topSp:setAltas("common_altas_3", "ui_djc_window_004");
		if self.rankNum == nil then
			self.rankNum = Lua_NumberImage.new(self.content);
			self.rankNum.pivot = 0;
			self.rankNum.numOffsetX = -5;
			self.rankNum.numAtlas = "number";
			self.rankNum.preStr = "ui_djc_title_0";
		end
		self.rankNum.num = data.rank;
		self.rankNum:setEnable(true);
		self.rankNum:setLocation(-288, 0, 0);
	end
end