--联盟系统 红包详情Window
Lua_AllianceRedPacketDetailWindow = class("Lua_AllianceRedPacketDetailWindow", Lua_Window);

function Lua_AllianceRedPacketDetailWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.isClickClose = true;
	self.showBlackMask = true;

	self.windowName = "Lua_AllianceRedPacketDetailWindow";
	self.skinName = "AllianceRedPacketDetailWindow_skin";
end

function Lua_AllianceRedPacketDetailWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_LEAGUE_REDPACKET_DETAIL", self, self.updateData);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceRedPacketDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setScale(0.7, 0.7);
	self.avatarItem:setLocation(5, 300, 0);

	self.dragList = Lua_DragList.new(self.content, 540, 400, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_AllianceRedPacketDetailItem, 535, 95, 1);
	self.dragList:setCellSpacing(0, 10);
    self.dragList:setLocation(0, -75, 0);
end

function Lua_AllianceRedPacketDetailWindow:showWin(param)
	self:superCall("showWin", param);

	self.titleTxt.text = param.red_package_name;

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sViewAllianceRedPacket(param.redPackUid);
end

function Lua_AllianceRedPacketDetailWindow:dispose()
	self:superCall("dispose");
end

function Lua_AllianceRedPacketDetailWindow:updateData(data)
	local itemInfo = data.left_item;
	local toolVo = Lua_ToolVo.new(self.showData.showItem[1]);
	self.moneyIcon:setAltas(toolVo.atlas, toolVo.sprite);
	self.moneyTxt.text = numberTrans(itemInfo.amount) .. "/" .. numberTrans(self.showData.showItem[2]);
	self.remianTimeTxt.text = LanUtil.formateStr(201254, Lua_TimeTransform.transSeconds1(itemInfo.expired_tick - DataCenter.roleData.serverTime));
	
	local senderInfo = data.sender;
	self.avatarItem:setRoleDressUp(senderInfo.dress_info);
	self.nameTxt.text = senderInfo.name;

	self.remianNumTxt.text = LanUtil.formateStr(201170, data.left_num .. "/" .. self.showData.single_send_num);

	local arr = Array();
	for k, v in ipairs(data.draw_info) do
		arr:add({info = v, itemVo = toolVo});
	end
	self.dragList:setArrayData(arr);
end



























Lua_AllianceRedPacketDetailItem = class("Lua_AllianceRedPacketDetailItem", Lua_ListCell);

function Lua_AllianceRedPacketDetailItem:ctor(p)
	self:superCall("ctor", p, "AllianceRedPacketDetailItem_skin");
end

function Lua_AllianceRedPacketDetailItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setLocation(-211, 0, 0);
	self.avatarItem:setScale(0.7, 0.7);
end

function Lua_AllianceRedPacketDetailItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceRedPacketDetailItem:setCellSeqIndex(idx)
	self:superCall("setCellSeqIndex", idx);
	self.bestIcon:setEnable(self.cellSeqIndex == 1);
end

function Lua_AllianceRedPacketDetailItem:setData(data)
	local info = data.info;
	if tonumber(info.role_id) == DataCenter.roleData.roleId then
		self.nameTxt.text = LanUtil.formateStr(201256, info.name);
		self.mineBg:setEnable(true);
		self.timeTxt.colorStr = Lua_ColorDefine.transColorStr("A0754C");
		self.moneyTxt.colorStr = Lua_ColorDefine.transColorStr("8B5E34");
	else
		self.nameTxt.text = LanUtil.formateStr(201255, info.name);
		self.mineBg:setEnable(false);
		self.timeTxt.colorStr = Lua_ColorDefine.transColorStr("F1D0A8");
		self.moneyTxt.colorStr = Lua_ColorDefine.transColorStr("FFF3E4");
	end
	self.avatarItem:setRoleDressUp(info.dress_info);
	self.timeTxt.text = Lua_TimeTransform.transSeconds8(info.draw_tick);
	self.moneyTxt.text = info.draw_num;
	
	self.moneyIcon:setAltas(data.itemVo.atlas, data.itemVo.sprite);
end