--联盟系统 发送联盟红包Window
checkRequire("Lua_ScrollBoard");
Lua_AllianceRedPacketPanel = class("Lua_AllianceRedPacketPanel", Lua_DisplayObject);

function Lua_AllianceRedPacketPanel:ctor(p)
	self:superCall("ctor", p, "AllianceRedPacketPanel_skin");
end

function Lua_AllianceRedPacketPanel:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("UPDATE_LEAGUE_REDPACKET", self, self.updateData);
	self:addLuaEvent("UPDATE_LEAGUEREDPACKET_SELECT", self, self.updateShow);

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceRedPacketInface();

	self.sendClickTime = DataCenter.roleData.serverTime - 5;

	self.scrollBoard = Lua_ScrollBoard.new(self.content, Lua_AxisDefine.Horizontal, 710, 510);
	self.scrollBoard:setListCell(Lua_AllianceRedPacketItem, 382, 510);
	self.scrollBoard:setRectAnchor(1);
	self.scrollBoard:setChangeScale(1, 0.8, 0.001);
	self.scrollBoard:setSiblingIndex(1);

	self.rewardList = Lua_ItemIconList.new(self.downObj);
	self.rewardList:setLocation(-60, -410, 0);
	-- self.rewardList:setRectAnchor(7);
	self.rewardList.pivot = 1;
	self.rewardList.canClick = true;

	self.sendBtn:addClickFuntion(self, self.onSendBtnClick);

	local offsetY = self.adaptHeight < 0 and 155 or 0;
	self.scrollBoard:setLocation(0, -575 + offsetY, 0);
	self.subBtn:setLocation(-284.4, -575 + offsetY, 0);
	self.addBtn:setLocation(285.3, -575 + offsetY, 0);
end

function Lua_AllianceRedPacketPanel:dispose()
	if self.scrollBoard ~= nil then
		self.scrollBoard:dispose();
		self.scrollBoard = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceRedPacketPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	local offsetY = self.adaptHeight < 0 and 155 or 0;
	self.scrollBoard:setLocation(0, -575 + offsetY, 0);
	self.subBtn:setLocation(-284.4, -575 + offsetY, 0);
	self.addBtn:setLocation(285.3, -575 + offsetY, 0);
end

function Lua_AllianceRedPacketPanel:updateData(data)
	self.data = data;
	self.scrollBoard:setLuaArrayData(data, false);
	if self.index == nil then
		self.scrollBoard:moveToIndex(1, true);
	end
end

function Lua_AllianceRedPacketPanel:updateShow(index)
	self.index = index;

	local vo = self.data[index];
	local itemVo = Lua_ResourcesData.getConfigDataById(vo.showItem[1]);
	self.moneyItem:setAltas(itemVo.iconAtlas, itemVo.iconSprite);
	self.moneyNumTxt.text = vo.showItem[2];
	self.redPacketNumTxt.text = vo.single_send_num;
	self.rewardList:setArrayData(vo.ret_reward);
	self.sendBtn.label = LanUtil.formateStr(201167, vo.price);
	self.messageInput.text = "";
end

function Lua_AllianceRedPacketPanel:onSendBtnClick()
	if DataCenter.roleData.serverTime - self.sendClickTime <= 3 then
		OperateAlert.showLangValue(201114);
		return;
	end
	self.sendClickTime = DataCenter.roleData.serverTime;

	local vo = self.data[self.index];
	if vo.showNum <= 0 then
		OperateAlert.showLangValue(201257);
		return;
	end

	if Lua_CommonUtil.checkIsInvalid(self.messageInput.text, false) then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sSendAllianceRedPacket(vo.recharge_id, self.messageInput.text);

	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(vo.recharge_id);
	DataCenter.sdkInterface:PointOut(tonumber(rechargeInfo.gold), tonumber(rechargeInfo.money),tonumber(rechargeInfo.money_type), tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
end


























Lua_AllianceRedPacketItem = class("Lua_AllianceRedPacketItem", Lua_ScrollBoardCell);

function Lua_AllianceRedPacketItem:ctor(p)
	self:superCall("ctor", p, "AllianceRedPacketItem_skin");
end

function Lua_AllianceRedPacketItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_AllianceRedPacketItem:dispose()
	self:superCall("dispose");
end

function Lua_AllianceRedPacketItem:setData(data)
	self.data = data;
	self.titleTxt.text = data.red_package_name;
	self.remianTxt.text = LanUtil.formateStr(201190, data.showNum);
end

function Lua_AllianceRedPacketItem:onPressClick(idx)
	Lua_MsgUtil.callFunc("UPDATE_LEAGUEREDPACKET_SELECT", idx);
end