--联盟系统 抢红包Window
Lua_AllianceRedPacketRobPanel = class("Lua_AllianceRedPacketRobPanel", Lua_DisplayObject);

function Lua_AllianceRedPacketRobPanel:ctor(p)
	self:superCall("ctor", p, "AllianceRedPacketRobPanel_skin");
end

function Lua_AllianceRedPacketRobPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.bg1:SetDimensions(720, 986 + self.adaptHeight);
	self.bg2:SetDimensions(720, 988 + self.adaptHeight);

	self:addLuaEvent("UPDATE_LEAGUE_ROB_REDPACKET", self, self.updateData);
	self:addLuaEvent("UPDATE_LEAGUE_REDPACKET_LEFT_NUM", self, self.updateNumChange);

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceRedPacketInfo();

	self.dragList = Lua_DragList.new(self.content, 650, 950 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_AllianceRedPacketRobItem, 310, 405, 2);
	self.dragList:setCellSpacing(20, 20);
    self.dragList:setLocation(0, -125, 0);
    self.dragList.tweenId = 2016;
end

function Lua_AllianceRedPacketRobPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceRedPacketRobPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.bg1:SetDimensions(720, 986 + adaptHeight);
	self.bg2:SetDimensions(720, 988 + adaptHeight);
	self.dragList:setContentRect(650, 950 + adaptHeight);
end

function Lua_AllianceRedPacketRobPanel:updateData()
	local arr = DataCenter.allianceData.robRedPacketArr;
	arr:sort("sort", false);
	self.dragList:setArrayData(arr);
	self:updateNumChange();
end

function Lua_AllianceRedPacketRobPanel:updateNumChange()
	self.leftNumTxt.text = LanUtil.formateStr(201116, DataCenter.allianceData.leagueRedPacketNum);
	self.remainNumTxt.text = LanUtil.formateStr(201117, DataCenter.allianceData.welfareRedPacketNum);
end

















Lua_AllianceRedPacketRobItem = class("Lua_AllianceRedPacketRobItem", Lua_ListCell);

function Lua_AllianceRedPacketRobItem:ctor(p)
	self:superCall("ctor", p, "AllianceRedPacketRobItem_skin");
end

function Lua_AllianceRedPacketRobItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_AllianceRedPacketRobItem:dispose()
	self:superCall("dispose");
end

function Lua_AllianceRedPacketRobItem:setData(data)
	self.data = data;

	local itemVo = Lua_ToolVo.new(data.showItem[1]);
	self.itemNum.text = data.showItem[2];
	self.showIcon:setAltas(itemVo.atlas, itemVo.sprite);
	self.showIcon:resetSize();
	self.nameTxt.text = data.red_package_name;
	self.titleTxt.text = data.showDesc;
	self.playerNameTxt.text = LanUtil.formateStr(201169, data.playerName);

	if data.state == 1 then
		self.maskObj:SetActive(true);
		self.signIcon:setAltas("alliance_atlas_1", "ui_sq_label_08")
	else
		if data.leftNum > 0 then
			self.maskObj:SetActive(false);
		else
			self.maskObj:SetActive(true);
			self.signIcon:setAltas("alliance_atlas_1", "ui_sq_label_12")
		end
	end

	local limitNum;
	if data.type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.LEAGUE then
		limitNum = DataCenter.allianceData.leagueRedPacketNum;
	elseif data.type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.WELFARE then
		limitNum = DataCenter.allianceData.welfareRedPacketNum;
	end
	if data.state == 0 and limitNum > 0 then
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content);
			self.redPointIcon:createRedPointEff();
			self.redPointIcon:setLocation(130, 180, 0);
		end
		self.redPointIcon:updateRedPointShow(true);
	else
		if self.redPointIcon ~= nil then
			self.redPointIcon:updateRedPointShow(false);
		end
	end
end

function Lua_AllianceRedPacketRobItem:onPressClick()
	if self.data.state == 0 and self.data.leftNum > 0 then
		local limitNum;
		if self.data.type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.LEAGUE then
			limitNum = DataCenter.allianceData.leagueRedPacketNum;
		elseif self.data.type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.WELFARE then
			limitNum = DataCenter.allianceData.welfareRedPacketNum;
		end
		if limitNum <= 0 then
			local limitStr = self.data.type == Lua_AllianceData.RED_PACKET_MAIN_TYPE.LEAGUE and LanUtil.getValue(201296) or LanUtil.getValue(201297);
			OperateAlert.show(LanUtil.formateStr(201168, limitStr));
			return;
		end
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sReceiveAllianceRedPacket(self.data.redPackUid);
	else
		Lua_WindowUtil.openWin("Lua_AllianceRedPacketDetailWindow", Lua_WinParam.ACTION_OPEN, self.data);
	end
end