--联盟系统 红包主界面Window
checkRequire("Lua_AllianceRedPacketPanel");
checkRequire("Lua_AllianceWelfareRedPacketPanel");
checkRequire("Lua_AllianceRedPacketRobPanel");
checkRequire("Lua_AllianceRedPacketRankPanel");
Lua_AllianceRedPacketWindow = class("Lua_AllianceRedPacketWindow", Lua_Window);

function Lua_AllianceRedPacketWindow:ctor()
	self:superCall("ctor");

	self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.showBlackMask = true;
	self.layer = MainWinDefine.MAIN_MENU_TOP_LAYER;

	self.windowName = "Lua_AllianceRedPacketWindow";
	self.skinName = "AllianceRedPacketWindow_skin";
end

function Lua_AllianceRedPacketWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
	self:addLuaEvent("ALLIANCE_REDPACKET_BTN", self, self.onBtnClick);

	self.btnInfoArr = Array();
	self.btnInfoArr:add({textStr = LanUtil.getValue(201226), iconStr = "ui_sq_button_007", panel = Lua_AllianceRedPacketPanel});
	self.btnInfoArr:add({textStr = LanUtil.getValue(201227), iconStr = "ui_sq_button_006", panel = Lua_AllianceWelfareRedPacketPanel, redPointId = Lua_RedPointList.LeagueRedPacketWelfare});
	self.btnInfoArr:add({textStr = LanUtil.getValue(201228), iconStr = "ui_sq_button_005", panel = Lua_AllianceRedPacketRobPanel, redPointId = Lua_RedPointList.LeagueRedPacketRob});
	self.btnInfoArr:add({textStr = LanUtil.getValue(201229), iconStr = "ui_sq_button_004", panel = Lua_AllianceRedPacketRankPanel});

	self.dragList = Lua_DragList.new(self.content, 480, 120, Lua_AxisDefine.Horizontal);
	self.dragList:setListCell(Lua_AllianceRedPacketBtn, 120, 120, 1);
	self.dragList:setRectAnchor(7);
    self.dragList:setLocation(120, 50, 0);
    self.dragList:setArrayData(self.btnInfoArr);
    self.dragList:setSelected(1);
    self.dragList.showList[1]:onPressClick();
end

function Lua_AllianceRedPacketWindow:onBtnClick(index)
	if self.index == index then return end
	self.index = index;

	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	local panel = self.btnInfoArr[index].panel;
	self.curPanel = panel.new(self.content);
	self.curPanel:setSiblingIndex(0);
	self.curPanel:setRectAnchor(9)
end

function Lua_AllianceRedPacketWindow:dispose()
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self:superCall("dispose");
end












Lua_AllianceRedPacketBtn = class("Lua_AllianceRedPacketBtn", Lua_ListCell);

function Lua_AllianceRedPacketBtn:ctor(p)
	self:superCall("ctor", p, "AllianceRedPacketBtn_skin");
end

function Lua_AllianceRedPacketBtn:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_AllianceRedPacketBtn:dispose()
	self:superCall("dispose");
end

function Lua_AllianceRedPacketBtn:setData(data)
	self.data = data;
	self:setRedDot(data.redPointId);
end

function Lua_AllianceRedPacketBtn:onPressClick()
	Lua_MsgUtil.callFunc("ALLIANCE_REDPACKET_BTN", self.cellSeqIndex);
	return true;
end

function Lua_AllianceRedPacketBtn:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);

	if bSelect then
		self.icon:setAltas("alliance_atlas_1", self.data.iconStr .. "_p");
	else
		self.icon:setAltas("alliance_atlas_1", self.data.iconStr .. "_n");
	end
	self.selectBg:setEnable(bSelect);
end

function Lua_AllianceRedPacketBtn:setRedDot(id)
	if strIsNullOrEmpty(id) then
		if self.redPointIcon ~= nil then
			self.redPointIcon:changeRedPoint(nil);
		end
	else
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content);
			self.redPointIcon:setLocation(40, 30);
		end
		self.redPointIcon:changeRedPoint(id);
	end
end










