--联盟系统 福利红包Window
Lua_AllianceWelfareRedPacketPanel = class("Lua_AllianceWelfareRedPacketPanel", Lua_DisplayObject);

function Lua_AllianceWelfareRedPacketPanel:ctor(p)
	self:superCall("ctor", p, "AllianceWelfareRedPacketPanel_skin");
end

function Lua_AllianceWelfareRedPacketPanel:buildShowItem()
	self:superCall("buildShowItem");
	
	self.bg1:SetDimensions(720, 986 + self.adaptHeight);
	self.bg2:SetDimensions(720, 988 + self.adaptHeight);

	self:addLuaEvent("UPDATE_LEAGUE_WELFARE_REDPACKET", self, self.updateData);

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sWalfareRedPacketInfo();

	self.dragList = Lua_DragList.new(self.content, 650, 950 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_AllianceWelfareRedPacketItem, 310, 405, 2);
	self.dragList:setCellSpacing(20, 20);
    self.dragList:setLocation(0, -125, 0);
    self.dragList.tweenId = 2016;
end

function Lua_AllianceWelfareRedPacketPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceWelfareRedPacketPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.bg1:SetDimensions(720, 986 + adaptHeight);
	self.bg2:SetDimensions(720, 988 + adaptHeight);
	self.dragList:setContentRect(650, 950 + adaptHeight);
end

function Lua_AllianceWelfareRedPacketPanel:updateData()
	local arr = DataCenter.allianceUtil:getWelfareRedPacketLimitArr(DataCenter.roleData.league_position);
	arr:sort("sendSort", false);
	self.dragList:setArrayData(arr);
end






















Lua_AllianceWelfareRedPacketItem = class("Lua_AllianceWelfareRedPacketItem", Lua_ListCell);

function Lua_AllianceWelfareRedPacketItem:ctor(p)
	self:superCall("ctor", p, "AllianceWelfareRedPacketItem_skin");
end

function Lua_AllianceWelfareRedPacketItem:buildShowItem()
	self:superCall("buildShowItem");

	self.sendBtn:addClickFuntion(self, self.onSendBtnClick);
end

function Lua_AllianceWelfareRedPacketItem:dispose()
	if self.redDotItem ~= nil then
		self.redDotItem:dispose();
		self.redDotItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceWelfareRedPacketItem:setData(data)
	self.data = data;

	local itemVo = Lua_ToolVo.new(data.showItem[1]);
	self.showIcon:setAltas(itemVo.atlas, itemVo.sprite);
	self.showIcon:resetSize();
	self.itemNum.text = data.showItem[2];
	self.nameTxt.text = data.red_package_name;
	self.titleTxt.text = data.showDesc;
	self.ownerTxt.text = LanUtil.formateStr(201215, data.showNum);

	if data.showNum > 0 then
		if self.redDotItem == nil then
			self.redDotItem = Lua_RedPointIcon.new(self.content);
			self.redDotItem:createRedPointEff();
			self.redDotItem:setLocation(55, -135, 0);
		end
		self.redDotItem:updateRedPointShow(true);
	else
		if self.redDotItem ~= nil then
			self.redDotItem:updateRedPointShow(false);
		end
	end
end

function Lua_AllianceWelfareRedPacketItem:onSendBtnClick()
	if self.data.showNum > 0 then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sSendWalfareRedPacket(self.data.id, "");
	else
		OperateAlert.showLangValue(201299);
	end
end