--联盟系统 联盟科技默认Panel
checkRequire("Lua_AllianceSciencePointItem");
Lua_AllianceScienceDefaultPanel = class("Lua_AllianceScienceDefaultPanel", Lua_DisplayObject);
function Lua_AllianceScienceDefaultPanel:ctor(p)
	self:superCall("ctor", p, "AllianceScienceDefaultPanel_skin");
end

function Lua_AllianceScienceDefaultPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.checkTime = DataCenter.roleData.serverTime;

	self.txt:setLangValue(201247);
	self:addLuaEvent("UPDATE_LEAGUE_SCIENCEINFO", self, self.updateEffect);
	self:addLuaEvent("SELECT_LEAGUE_JOB_BTN", self, self.onBtnClick);

	local idx;
	local item;
	local careerList = DataCenter.allianceUtil:getConstConfig("science_career_sort", 5);
	self.btnArr = Array();
	for i = 1, #careerList do
		idx = careerList[i];
		item = Lua_AllianceScienceJobBtn.new(self.content, idx);
		item:setTxt(DataCenter.heroUtil:getHeroCareer(idx));
		item:setLocation(305, 340 - (i - 1) * 120, 0);
		self.btnArr:add(item);
	end

	self.pointItemArr = Array();
	local pointPosList = {{-23, 268.5}, {141, 176}, {141.6, -11.5}, {-22, -101}, {-183, -10}, {-187, 174}};
	for i = 1, Lua_AllianceData.SCIENTCE_POINT_NUM do
		item = Lua_AllianceSciencePointItem.new(self.content);
		item:setLocation(pointPosList[i][1], pointPosList[i][2]);
		self.pointItemArr:add(item);
	end

	self.lightBtn:addClickFuntion(self, self.onLightBtnClick);
	self.resetTxt:addClickFuntion(self, self.onResetBtnClick);
	self.tipIcon:addClickFuntion(self, self.onTipIconClick);

	self:onBtnClick(2);
end

function Lua_AllianceScienceDefaultPanel:dispose()
	Lua_CommonUtil.removeTimer(self, self.updateData);
	self:removeTimer(self, self.onPlayTween);

	if self.btnArr ~= nil then
		self.btnArr:dispose();
		self.btnArr = nil
	end
	if self.pointItemArr ~= nil then
		self.pointItemArr:dispose();
		self.pointItemArr = nil
	end
	if self.propTxtArr ~= nil then
		self.propTxtArr:dispose();
		self.propTxtArr = nil
	end
	if self.goldItem ~= nil then
		self.goldItem:dispose();
		self.goldItem = nil;
	end
	if self.contriItem ~= nil then
		self.contriItem:dispose();
		self.contriItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceScienceDefaultPanel:onBtnClick(index)
	self.scienceType = index;
	self.isPlayTween = true;
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceScience(index);

	local item;
	local len = self.btnArr:getSize();
	local selectIdx = 1;
	for i = 1, len do
		item = self.btnArr[i];
		item:setSiblingIndex(i);
		if item.idx == index then
			selectIdx = i;
			item:updateSelect(true);
		else
			item:updateSelect(false);
		end
	end
	self.btnArr[selectIdx]:setSiblingIndex(len);
end

function Lua_AllianceScienceDefaultPanel:updateEffect()
	if DataCenter.allianceData.isPlayEff then
		if self.showEff == nil then
			self.showEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_gh_jqdl_01", "ui_gh_jqdl_01", 2, 1);
			self.showEff.siblingIndex = 10;
		else
			self.showEff:setEnable(false);	
			self.showEff:setEnable(true);
		end

		if self.curNode ~= nil and self.curNode == self.nextNode then --防止数据未刷新
			self.curNode = self.curNode + 1;
		else
			self.curNode = self.nextNode;
		end
		if self.curNode > Lua_AllianceData.SCIENTCE_POINT_NUM then
			self.curNode = Lua_AllianceData.SCIENTCE_POINT_NUM;
		end
		self.pointItemArr[self.curNode]:showEff();

		if DataCenter.roleData.serverTime - self.checkTime < 2 then
			if self.curNode ~= Lua_AllianceData.SCIENTCE_POINT_NUM then
				self:updateData();
			end
		end
		self.checkTime = DataCenter.roleData.serverTime;

		if self.curNode == Lua_AllianceData.SCIENTCE_POINT_NUM then
			DataCenter.allianceData:refreshLastScienceInfo();
			self.lightBtn:setBtnEnable(false);		
		end

		Lua_CommonUtil.delayCall(2, self, self.updateData);
	else
		self.curNode = nil;
		self:updateData();
	end
end

function Lua_AllianceScienceDefaultPanel:updateData()
	self.data = DataCenter.allianceData:getScienceInfo(self.scienceType);

	local careerName = DataCenter.heroUtil:getHeroCareer(self.data.scienceType);
	local curLevel = self.data.nextLightVo.level;
	local maxLevel = DataCenter.allianceUtil:getConstConfig("science_lvl_limit", 1);

	self.titleTxt.text = LanUtil.formateStr(201148, careerName, curLevel);
	self.expTxt.text = LanUtil.formateStr(201112, curLevel, maxLevel);
	self.lightBtn:setEnable(self.data.curScienceId ~= self.data.nextScienceId);

	local costVo = Lua_ToolVo.new(self.data.nextLightVo.gold_coins_consume[1], self.data.nextLightVo.gold_coins_consume[2]);
	if self.goldItem == nil then
		self.goldItem = Lua_ConsumeIconItem.new(self.content);
		self.goldItem:setRectAnchor(7);
		self.goldItem:setLocation(-140, 240, 0);
		self.goldItem:setBg("alliance_atlas_2", "ui_tdq_window_004", 206, 29);
		self.goldItem:setColorStr("30F451", "E01B1B");
	end
	self.goldItem:setData(costVo);
	self.goldItem:setEnable(self.data.curScienceId ~= self.data.nextScienceId);

	costVo = Lua_ToolVo.new(self.data.nextLightVo.contri_consume[1], self.data.nextLightVo.contri_consume[2]);
	if self.contriItem == nil then
		self.contriItem = Lua_ConsumeIconItem.new(self.content);
		self.contriItem:setRectAnchor(7);
		self.contriItem:setLocation(140, 240, 0);
		self.contriItem:setBg("alliance_atlas_2", "ui_tdq_window_004", 206, 29);
		self.contriItem:setColorStr("30F451", "E01B1B");
	end
	self.contriItem:setData(costVo);
	self.contriItem:setEnable(self.data.curScienceId ~= self.data.nextScienceId);

	local isShow = false;
	self.isMaxLevel = maxLevel == curLevel;
	self.nextNode = self.data.nextLightVo.node;
	for i = 1, Lua_AllianceData.SCIENTCE_POINT_NUM do
		if self.data.curScienceId ~= 0 then
			isShow = self.data.getSciencePointArr[i].id <= self.data.curScienceId;
		end
		self.pointItemArr[i]:setData(self.data.getSciencePointArr[i], isShow, (i == self.nextNode) and self.isMaxLevel == false, self.isPlayTween);
		if self.isPlayTween then self.pointItemArr[i]:setEnable(false); end
	end

	if self.isPlayTween then
		self.isPlayTween = false;
		self.playIdx = 0;
		self:onPlayTween();
		self:addTimer("onPlayTween", 0.05, self, self.onPlayTween);
	end

	if self.propTxtArr == nil then
		self.propTxtArr = Array();
	end
	local showArr = self.data.addPropArr;
	local len = showArr ~= nil and showArr:getSize() or 0;
	local num = self.propTxtArr:getSize();
	local count = len > num and len or num;

	local label;
	for i = 1, count do
		label = self.propTxtArr[i];
		if label == nil then
			label = UICreate.createLabel(self.content, "", 0, 0, 200, 30, 24);
			label.anchorValue = 7;
			label:setLocation(-204 + (i - 1) % 3 * 215, 351 - Mathf.Floor((i - 1) / 3) * 62, 0);
			self.propTxtArr:add(label);
		end

		if i <= len then
			label.text = "<color=#514133>" .. showArr[i].show_name .. ":</color><color=#459252>+" .. showArr[i].showValue .. "</color>";
		else
			label.text = "";
		end
	end
	self.resetTxt:setEnable(self.data.curScienceId ~= 0);
	self.lightBtn:setBtnEnable(true);
end

function Lua_AllianceScienceDefaultPanel:onPlayTween()
	self.playIdx = self.playIdx + 1;
	if self.playIdx > Lua_AllianceData.SCIENTCE_POINT_NUM then
		self:removeTimer(self, self.onPlayTween);
		return;
	end
	local item = self.pointItemArr[self.playIdx];
	TweenUtil.getInstance():stop(item.content);
	item:setEnable(true);
	item:setScale(1.35, 1.35, 1.35);
	TweenUtil.getInstance():addTweenTargetAlpha(item.content, 0.5, 0, -1, true);
	TweenUtil.getInstance():addTweenTargetScale(item.content, 0.5, 0, 1, 1, 1);

	if (self.playIdx == self.nextNode) and self.isMaxLevel == false then
		item:startTween();
	end
end

function Lua_AllianceScienceDefaultPanel:onLightBtnClick(go)
	local contri_consume = self.data.nextLightVo.contri_consume;
	local costId = DataCenter.packData:checkConsumeEnough(contri_consume);
	if costId == nil then
		local gold_coins_consume = self.data.nextLightVo.gold_coins_consume;
		costId = DataCenter.packData:checkConsumeEnough(gold_coins_consume);
		if costId == nil then
			Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceSciencePoint(self.data.scienceType);
		else
			DataCenter.packUtil:openPathWindow(costId);
		end
	else
		DataCenter.packUtil:openPathWindow(costId);
	end
end

function Lua_AllianceScienceDefaultPanel:onResetBtnClick(go)
	self.resetCostNum = DataCenter.allianceUtil:getConstConfig("science_first_reset_consume", 5)[2] + DataCenter.allianceUtil:getConstConfig("science_every_reset_consume", 1) * self.data.resetNum;
	local costId = DataCenter.allianceUtil:getConstConfig("science_first_reset_consume", 5)[1];
	local tipsData = {
		des = LanUtil.formateStr(201149, DataCenter.heroUtil:getHeroCareer(self.data.scienceType), self.resetCostNum, spliceIconStrById(costId)),
		btnType = 1,
		time = DataCenter.allianceUtil:getConstConfig("league_sure_click_time", 5)[4],
		owner = self,
		sureFun = self.onSureFun
	};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_AllianceScienceDefaultPanel:onSureFun()
	if DataCenter.moneyData:isMoneyEnough(DataCenter.allianceUtil:getConstConfig("science_first_reset_consume", 5)[1], self.resetCostNum, true, true, false) then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sResetAllianceScience(self.data.scienceType);
	end
end

function Lua_AllianceScienceDefaultPanel:onTipIconClick()
	local tipsData = { des = LanUtil.getValue(201216), posX = 205, posY = -267 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end
























Lua_AllianceScienceJobBtn = class("Lua_AllianceScienceJobBtn", Lua_DisplayObject);

function Lua_AllianceScienceJobBtn:ctor(p, idx)
	self.idx = idx;
	self.isSelect = false;
	self:superCall("ctor", p, "AllianceScienceJobBtn_skin");
end

function Lua_AllianceScienceJobBtn:buildShowItem()
	self:superCall("buildShowItem");

	self.clickBg.clickScale = false;
	self.clickBg:addClickFuntion(self, self.onClick);

	local redDotId = DataCenter.allianceUtil:getScienceRedDot(self.idx);
	self.redPointIcon = Lua_RedPointIcon.new(self.content, redDotId);
	self.redPointIcon:setLocation(30, 30);
	self.redPointIcon:clickHandler();
end

function Lua_AllianceScienceJobBtn:dispose()
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceScienceJobBtn:setTxt(txtStr)
	self.txt.text = txtStr;
end

function Lua_AllianceScienceJobBtn:updateSelect(val)
	self.isSelect = val;

	if val then
		self.bg:setAltas("alliance_atlas_1", "ui_sq_button_014_p");
		self.txt.colorStr = Lua_ColorDefine.transColorStr("9e7660");
	else
		self.bg:setAltas("alliance_atlas_1", "ui_sq_button_014_n");
		self.txt.colorStr = Lua_ColorDefine.transColorStr("8b6854");
	end
end

function Lua_AllianceScienceJobBtn:onClick(go)
	if self.isSelect == false then
		Lua_MsgUtil.callFunc("SELECT_LEAGUE_JOB_BTN", self.idx);
	end
end