--联盟系统 联盟宝库购买Window
Lua_AllianceTreasuryBuyWindow = class("Lua_AllianceTreasuryBuyWindow", Lua_Window);

function Lua_AllianceTreasuryBuyWindow:ctor()
	self:superCall("ctor");

	self.isClickClose = true;
	self.showBlackMask = true;
	
	self.windowName = "Lua_AllianceTreasuryBuyWindow";
	self.skinName = "AllianceTreasuryBuyWindow_skin";
end

function Lua_AllianceTreasuryBuyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(-165, 110, 0);

	self.subBtn:addClickFuntion(self, self.onSubBtnClick);
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_AllianceTreasuryBuyWindow:showWin(param)
	self:superCall("showWin", param);

	local itemVo = param.getItemVo;
	self.itemIcon:setData(itemVo);
	self.itemIcon:showNum(param.base_amount);
	self.itemNameTxt.text = itemVo.name;

	local costVo = Lua_ToolVo.new(param.sell_league_coin[1]);
	self.costIcon:setAltas(costVo.atlas, costVo.sprite);
	self.costNumTxt.text = param.sell_league_coin[2];

	self.singlePrice = param.sell_league_coin[2];
	self.buyCount = 1;

	self:onCountDown();
	self:addTimer("onCountDown", 1, self, self.onCountDown);

	local moneyBuyNum = Mathf.Ceil(DataCenter.packData:getItemCountById(Lua_ResourcesDefine.DIAMOND) / self.singlePrice);
	local itemNum = Mathf.Ceil(itemVo.count / param.base_amount);
	self.limitBuyNum = moneyBuyNum <= itemNum == moneyBuyNum or itemNum;
	if self.limitBuyNum <= 0 then
		self.limitBuyNum = 1;
	end
	self:updateShow();
end

function Lua_AllianceTreasuryBuyWindow:dispose()
	self:removeTimer(self, self.onCountDown);
	
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceTreasuryBuyWindow:updateShow()
	self.buyNumTxt.text = LanUtil.formateStr(201188, self.buyCount);
	self.showNumTxt.text = self.buyCount;

	self.totalPrice = self.buyCount * self.singlePrice
	self.priceTxt.text = LanUtil.formateStr(201189, self.totalPrice);
end

function Lua_AllianceTreasuryBuyWindow:onSubBtnClick()
	local num = self.buyCount - 1;
	if num <= 0 then
		num = 1;
	end
	self.buyCount = num;
	self:updateShow();
end

function Lua_AllianceTreasuryBuyWindow:onAddBtnClick()
	local num = self.buyCount + 1;
	if num >= self.limitBuyNum then
		num = self.limitBuyNum;
	end
	self.buyCount = num;
	self:updateShow();
end

function Lua_AllianceTreasuryBuyWindow:onBuyBtnClick()
	if DataCenter.moneyData:isMoneyEnough(Lua_ResourcesDefine.DIAMOND, self.totalPrice, true, true, false) then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sTreasuryBuy(self.showData.index, self.buyCount * self.showData.base_amount, self.showData.type);
		self:hide();
	end
end

function Lua_AllianceTreasuryBuyWindow:onCountDown()
	local timeStr = Lua_TimeTransform.transSeconds18(self.showData.getItemVo.expired_tick - DataCenter.roleData.serverTime);
	self.timeTxt.text = LanUtil.formateStr(201187, self.showData.getItemVo.count, timeStr);
end
