--联盟系统 联盟宝库存放背包Window
Lua_AllianceTreasuryDepositWindow = class("Lua_AllianceTreasuryDepositWindow", Lua_Window);

function Lua_AllianceTreasuryDepositWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.showBlackMask = true;

	self.windowName = "Lua_AllianceTreasuryDepositWindow";
	self.skinName = "AllianceTreasuryDepositWindow_skin";
end

function Lua_AllianceTreasuryDepositWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("LEAGUE_TREASURY_DEPOSIT_ITEM", self, self.updateData);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceTreasuryDepositWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 630, 690, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_AllianceTreasuryDepositItem, 110, 130, 5);
    self.dragList:setLocation(0, -50, 0);

	self.btnInfoArr = Array();
	self.btnInfoArr:add({textStr = LanUtil.getValue(201217), type = Lua_AllianceData.TREASURY_TYPE.ITEM});
	self.btnInfoArr:add({textStr = LanUtil.getValue(201218), type = Lua_AllianceData.TREASURY_TYPE.CHIP});
	self.btnInfoArr:add({textStr = LanUtil.getValue(201219), type = Lua_AllianceData.TREASURY_TYPE.EQUIP});
	self.btnInfoArr:add({textStr = LanUtil.getValue(201220), type = Lua_AllianceData.TREASURY_TYPE.RUNE});

    self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.btnList:setButtonStyle("common_altas_1", "ui_common_tab_02", "ui_common_tab_02", 147, 80, 0.01, 1);
    self.btnList:setButtonText(0, 0, "5C504B", "8B5E34", 30, 30, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
    self.btnList:setButtonLine("common_altas_1", "ui_common_line_013", 2, 60);
    self.btnList:setButtonItem(134, 70);
    self.btnList:setLocation(-63, -450, 0);
    self.btnList:setClickCallBack(self, self.onBtnClick);
    self.btnList:setData(self.btnInfoArr);
    self.btnList:setSelected(1);

    self.leftArraw:setEnable(false);
    self.rightArraw:setEnable(false);
end

function Lua_AllianceTreasuryDepositWindow:dispose()
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceTreasuryInfo(DataCenter.allianceData.curTreasuryType);
	
	if self.btnInfoArr ~= nil then
		self.btnInfoArr:dispose();
		self.btnInfoArr = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceTreasuryDepositWindow:onBtnClick(index)
	if self.index == index then return end
	self.index = index;

	self:updateData();
end

function Lua_AllianceTreasuryDepositWindow:updateData()
	if self.index ~= nil then
		local arr = DataCenter.allianceUtil:getAllianceTreasuryArrByPack(self.btnInfoArr[self.index].type);
		self.dragList:setArrayData(arr);
	end
end



























Lua_AllianceTreasuryDepositItem = class("Lua_AllianceTreasuryDepositItem", Lua_ListCell);

function Lua_AllianceTreasuryDepositItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_AllianceTreasuryDepositItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 0, 0);
end

function Lua_AllianceTreasuryDepositItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceTreasuryDepositItem:setData(data)
	self.data = data;
	self.itemIcon:setData(data.getItemVo);
end

function Lua_AllianceTreasuryDepositItem:onPressClick()
	Lua_WindowUtil.openWin("Lua_AllianceTreasurySaveWindow", Lua_WinParam.ACTION_OPEN, self.data);
end