--联盟系统 联盟宝库易日志Window
checkRequire("Lua_AllianceLogItem");
Lua_AllianceTreasuryLogWindow = class("Lua_AllianceTreasuryLogWindow", Lua_Window);

function Lua_AllianceTreasuryLogWindow:ctor()
	self:superCall("ctor");

	self.w = 700;
	self.h = 800;
	self.showClose = true;
	self.showWinBg = true;
	self.isClickClose = true;
	self.showBlackMask = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";

	self.windowName = "Lua_AllianceTreasuryLogWindow";
	self.skinName = "AllianceTreasuryLogWindow_skin";
end

function Lua_AllianceTreasuryLogWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	
	self:addLuaEvent("LEAGUE_TREASURY_LOG_DETAIL", self, self.updateData);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceTreasuryLogWindow:buildShowItem()
	self:superCall("buildShowItem");

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceTreasuryLog();

	self.dragContainer = Lua_DragContainer.new(self.content, 634, 590, Lua_AxisDefine.Vertical);
    self.dragContainer:setCellSpacing(20, 10);
end

function Lua_AllianceTreasuryLogWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceTreasuryLogWindow:updateData(data)
	table.sort(data, function(a, b) return a.transaction_tick < b.transaction_tick end);

	local date;
	local logList = {};
	for k, v in ipairs(data) do
		date = tostring(os.date("%Y%m%d", v.log_tick));
		if logList[date] == nil then
			logList[date] = Array();
		end
		logList[date]:add(v);
	end
	
	self.dragContainer:clearList();
	for k, v in pairs(logList) do
		self.dragContainer:addSubContainer(Lua_AllianceLogItem, v, false);
	end
	self.dragContainer:updateChildPos();
	self.dragContainer:moveToIndex(1, true);
end