--联盟系统 联盟宝库物品存入Window
Lua_AllianceTreasurySaveWindow = class("Lua_AllianceTreasurySaveWindow", Lua_Window);

function Lua_AllianceTreasurySaveWindow:ctor()
	self:superCall("ctor");

	self.isClickClose = true;
	self.showBlackMask = true;
	
	self.windowName = "Lua_AllianceTreasurySaveWindow";
	self.skinName = "AllianceTreasurySaveWindow_skin";
end

function Lua_AllianceTreasurySaveWindow:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(-175, 110, 0);

	self.subBtn:addClickFuntion(self, self.onSubBtnClick);
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
	self.saveBtn:addClickFuntion(self, self.onSaveBtnClick);
end

function Lua_AllianceTreasurySaveWindow:showWin(param)
	self:superCall("showWin", param);

	local itemVo = param.getItemVo;
	self.itemIcon:setData(itemVo);
	self.itemIcon:showNum(param.base_amount);

	self.itemNameTxt.text = itemVo.name;
	self.itemNumTxt.text = LanUtil.formateStr(201184, param.packNum);

	local rewardVo = Lua_ToolVo.new(param.get_league_coin[1]);
	self.rewardIcon:setAltas(rewardVo.atlas, rewardVo.sprite);
	self.rewardtNumTxt.text = param.get_league_coin[2];

	self.singlePrice = param.get_league_coin[2];
	self.saveCount = 1;

	local packSaveTime = Mathf.Ceil(param.packNum / param.base_amount);
	local maxSaveTime = Mathf.Ceil(param.amount_limit / param.base_amount);
	self.limitSaveNum = packSaveTime <= maxSaveTime == packSaveTime or maxSaveTime;
	self:updateShow();
end

function Lua_AllianceTreasurySaveWindow:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceTreasurySaveWindow:updateShow()
	self.saveNumTxt.text = LanUtil.formateStr(201185, self.saveCount);
	self.showNumTxt.text = self.saveCount;

	self.totalPrice = self.saveCount * self.singlePrice
	self.priceTxt.text = LanUtil.formateStr(201186, self.totalPrice);
end

function Lua_AllianceTreasurySaveWindow:onSubBtnClick()
	local num = self.saveCount - 1;
	if num <= 0 then
		num = 1;
	end
	self.saveCount = num;
	self:updateShow();
end

function Lua_AllianceTreasurySaveWindow:onAddBtnClick()
	local num = self.saveCount + 1;
	if num >= self.limitSaveNum then
		num = self.limitSaveNum;
	end
	self.saveCount = num;
	self:updateShow();
end

function Lua_AllianceTreasurySaveWindow:onSaveBtnClick()
	if self.limitSaveNum <= 0 then
		OperateAlert.showLangValue(201171);
		return;
	end

	local curNum = DataCenter.allianceData.treasuryNumList[self.showData.id];
	if curNum ~= nil and curNum >= self.showData.treasury_limit then
		OperateAlert.showLangValue(201172);
		return;
	end
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sTreasuryPutItem(self.showData.id, self.saveCount * self.showData.base_amount, self.showData.uniqueId);
	self:hide();
end
