--联盟系统 联盟宝库主界面Window
Lua_AllianceTreasuryWindow = class("Lua_AllianceTreasuryWindow", Lua_Window);

function Lua_AllianceTreasuryWindow:ctor()
	self:superCall("ctor");

	self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.showBlackMask = true;
	self.layer = MainWinDefine.MAIN_MENU_TOP_LAYER;

	self.windowName = "Lua_AllianceTreasuryWindow";
	self.skinName = "AllianceTreasuryWindow_skin";
end

function Lua_AllianceTreasuryWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_LEAGUE_TREASURY_INFO", self, self.updateData);
	self:addLuaEvent("CLOSE_LEAGUE_OTHER_WINDOW", self, self.hide);
end

function Lua_AllianceTreasuryWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.contentBg:SetDimensions(693, 889 + self.adaptHeight);

	self.btnInfoArr = Array();
	self.btnInfoArr:add({textStr = LanUtil.getValue(201217), type = Lua_AllianceData.TREASURY_TYPE.ITEM});
	self.btnInfoArr:add({textStr = LanUtil.getValue(201218), type = Lua_AllianceData.TREASURY_TYPE.CHIP});
	self.btnInfoArr:add({textStr = LanUtil.getValue(201219), type = Lua_AllianceData.TREASURY_TYPE.EQUIP});
	self.btnInfoArr:add({textStr = LanUtil.getValue(201220), type = Lua_AllianceData.TREASURY_TYPE.RUNE});

    self.btnList = Lua_ButtonList.new(self.upObj, Lua_AxisDefine.Horizontal);
    self.btnList:setButtonStyle("alliance_atlas_1", "ui_sq_button_011_n", "ui_sq_button_011_n", 143, 46, 0.01, 1);
    self.btnList:setButtonText(0, 0, "ebebeb", "4b423d", 30, 30, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
    self.btnList:setButtonLine("common_altas_1", "ui_common_line_013", 2, 45);
    self.btnList:setButtonItem(110, 46);
    self.btnList:setLocation(0, 245, 0);
    self.btnList:setClickCallBack(self, self.onBtnClick);
    self.btnList:setData(self.btnInfoArr);
    self.btnList:setSelected(1);

    for i = 1, self.btnList.lineList:getSize() do
    	self.btnList.lineList[i].siblingIndex = i - 1;
    end

	self.dragContainer = Lua_DragContainer.new(self.content, 650, 700, Lua_AxisDefine.Vertical);
    self.dragContainer:setLocation(0, -152, 0);

    self.tipCtrl = DataCenter.allianceUtil:getConstConfig("treasury_tip_ctrl", 5);
    self.tipNum = #self.tipCtrl[2];
    self:addTimer("onCutTipShow", self.tipCtrl[1], self, self.onCutTipShow);
    self:onCutTipShow();

    self.detailTxt:addClickFuntion(self, self.onDetailLogClick)
	self.depositBtn:addClickFuntion(self, self.onDepositBtnClick);
	self.tipIcon:addClickFuntion(self, self.onTipIconClick);
end

function Lua_AllianceTreasuryWindow:dispose()
	self:removeTimer(self, self.onCutTipShow);

	if self.btnInfoArr ~= nil then
		self.btnInfoArr:dispose();
		self.btnInfoArr = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceTreasuryWindow:onScreenResize()
	self:superCall("onScreenResize", adaptHeight);

	self.contentBg:SetDimensions(693, 889 + self.adaptHeight);
end

function Lua_AllianceTreasuryWindow:onBtnClick(index)
	if self.index == index then return end
	self.index = index;
	DataCenter.allianceData.curTreasuryType = index;
	
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceTreasuryInfo(self.btnInfoArr[index].type);
end

function Lua_AllianceTreasuryWindow:updateData(data)
	local logInfo = DataCenter.allianceData.treasuryLog;
	local str = "";
	if #logInfo > 0 then
		table.sort(logInfo, function(a, b) return a.transaction_tick < b.transaction_tick end);
		for k, v in ipairs(logInfo) do
			str = str .. v.content .. "\n";
		end
	end
	self.logTxt.text = str;

	self.costNumTxt.text = DataCenter.packData:getItemCountById(201000016);

	self.dragContainer:clearList();
	for k, v in pairs(data) do
		self.dragContainer:addSubContainer(Lua_AllianceTreasuryItem, v, false, 0);
	end
	self.dragContainer:updateChildPos();
end

function Lua_AllianceTreasuryWindow:onDetailLogClick()
	Lua_WindowUtil.openWin("Lua_AllianceTreasuryLogWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_AllianceTreasuryWindow:onDepositBtnClick()
	Lua_WindowUtil.openWin("Lua_AllianceTreasuryDepositWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_AllianceTreasuryWindow:onCutTipShow()
	local index = Mathf.Ceil(Mathf.Random(1, self.tipNum));
	self.tipTxt.text = self.tipCtrl[2][index];
end

function Lua_AllianceTreasuryWindow:onTipIconClick()
	local tipsData = { des = LanUtil.getValue(201221), posX = 205, posY = -85 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end























Lua_AllianceTreasuryItem = class("Lua_AllianceTreasuryItem", Lua_DragContainerItem);

function Lua_AllianceTreasuryItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_AllianceTreasuryItem:buildShowItem()
    self:superCall("buildShowItem");

    self.itemArr = Array();
    self.hideArr = Array();
end

function Lua_AllianceTreasuryItem:dispose()
	if self.itemArr ~= nil then
		self.itemArr:dispose();
		self.itemArr = nil;
	end
	if self.hideArr ~= nil then
		self.hideArr:dispose();
		self.hideArr = nil;
	end
    self:superCall("dispose");
end

function Lua_AllianceTreasuryItem:setData(data)
	local item;
	local row = 1;
	local column = 1;
	local len = data:getSize();
	local itemNum = self.itemArr:getSize();
	local showLen = len >= itemNum and len or itemNum;
	for i = 1, showLen do
		item = self.itemArr[i];
		if item == nil then
			item = Lua_AllianceTreasuryShopItem.new(self.content);
			item:setRectAnchor(0);
			self.itemArr:add(item);
		end

		if i <= len then
			row = (i - 1) % 3;
			column = Mathf.Ceil(i / 3) - 1;
			item:setLocation(100 + 207 * row, -120 - 238 * column, 0);
			item:setData(data[i]);
		end
		item:setEnable(i <= len);
	end

	self.showHeight = (column + 1) * 238;
end

function Lua_AllianceTreasuryItem:getWidth()
	return 650;
end

function Lua_AllianceTreasuryItem:getHeight()
    return self.showHeight;
end


















Lua_AllianceTreasuryShopItem = class("Lua_AllianceTreasuryShopItem", Lua_DisplayObject);

function Lua_AllianceTreasuryShopItem:ctor(p)
	self:superCall("ctor", p, "AllianceTreasuryShopItem_skin");
end

function Lua_AllianceTreasuryShopItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showItem = Lua_ItemIcon.new(self.content);
	self.showItem:setLocation(0, 30, 0);
	self.showItem:setClick(self, self.onItemClick);

	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_AllianceTreasuryShopItem:dispose()
	if self.showItem ~= nil then
		self.showItem:dispose();
		self.showItem = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceTreasuryShopItem:setData(data)
	self.data = data;

	local costVo = Lua_ResourcesData.getConfigDataById(data.sell_league_coin[1]);
	self.costIcon:setAltas(costVo.iconAtlas, costVo.iconSprite);
	self.costIcon:SetDimensions(costVo.iconWidth, costVo.iconHeight);
	self.costTxt.text = data.sell_league_coin[2];

	local itemVo = data.getItemVo;
	self.showItem:setData(itemVo);
	self.showItem:showNum(data.base_amount);
	self.remainNumTxt.text = LanUtil.formateStr(201183, itemVo.count / data.base_amount);
end

function Lua_AllianceTreasuryShopItem:onItemClick()
	if self.data.getItemVo.main_type == Lua_PackDefine.EQUIP or self.data.getItemVo.main_type == Lua_PackDefine.RUNES then
		Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sAllianceTreasuryItemInfo(self.data.type, self.data.index);
	else
		DataCenter.packUtil:showItemInfo(self.data.getItemVo);
	end
end

function Lua_AllianceTreasuryShopItem:onBuyBtnClick()
	Lua_WindowUtil.openWin("Lua_AllianceTreasuryBuyWindow", Lua_WinParam.ACTION_OPEN, self.data);
end